<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class ExcelReport extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->model('user_model');
		$this->load->model('master_model');
		$this->load->model('report_model');
		//$this->load->model('stockupdate_model');
		
		if(!isset($_SESSION['user_logged'])) {
			$this->session->set_flashdata("error", "please login first to view dashboard");
			redirect("Login/login");
		}
	}
	
	public function report(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch'] = $this->user_model->get_branch();
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		
		$this->load->view('ExcelReport/report',$data);
	}
		
	public function exportReport(){
		$branchname = $_SESSION['branch_name'];
		$branch_id = $_SESSION['branch_id'];
		
		$fromdate = $this->input->post('from_date');
		$todate = $this->input->post('to_date');
		$report_type = $this->input->post('report_type');
		$from_date = date('Y-m-d', strtotime($fromdate));
		$to_date = date('Y-m-d', strtotime($todate));
		$branch = $this->input->post('branch');
				
        if($report_type == 'Purchase Order')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Purchase-Order.csv";
			
			$query = "SELECT P.purchase_id,P.purchase_no,DATE_FORMAT(P.purchase_date, '%d-%m-%Y') as purchase_date,P.purchase_time as time,P.venders_name as vendor_name,P.branchname,PO.purchase_order_id,PO.item_name,PO.unit_measurement as uom,PO.required_qty as qty,PO.item_price,PO.po_tax,PO.po_tax_amount,PO.actual_amount,PO.total_amount,PO.item_id,IT.itm_id as item_code,PO.cat_id from purchase_order P inner join purchase_order_item PO on P.purchase_id=PO.purchase_id inner join item_creation IT on PO.item_id=IT.item_id where P.purchase_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'GRN')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$enclosure = '"';
			$newline = "\r\n";
			$filename = "GRN.csv";
		
			$query = "SELECT G.gnr_id as grn_id,G.grn_no,G.invoice_no,G.vendor_name,DATE_FORMAT(G.grn_date, '%d-%m-%Y') as grn_date,G.grn_time,G.branchname,G.user_name,G.purchase_id,PG.purchase_grn_id,PI.item_name,PI.unit_measurement as uom,PG.grn_item_qty,PG.grn_item_price,PG.grn_tax,PG.grn_tax_amount,PG.grn_total_amount,PG.grn_grand,PG.purchase_order_id,PI.item_id,IT.itm_id as item_code,PI.cat_id as category_id from gnr_creation G inner join purchase_order_grn PG on G.gnr_id=PG.gnr_id inner join purchase_order_item PI on PG.purchase_order_id=PI.purchase_order_id inner join item_creation IT on PI.item_id=IT.item_id where G.grn_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			//$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline, $enclosure);
			force_download($filename, $data);
		}
		else if($report_type == 'Rejection')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Rejection.csv";
			
			$query = "SELECT R.rejection_no,DATE_FORMAT(R.rejection_date, '%d-%m-%Y') as rejection_date,R.rtime as rjn_time,G.grn_no,DATE_FORMAT(G.grn_date, '%d-%m-%Y') as grn_date,R.branchname,I.item_name,I.uom,RI.rejection_qty as rejected_qty,RI.rejection_price as price,RI.rejection_tax as tax,RI.rejection_tax_amount as tax_amt,RI.rejection_total_amount as total_amt,R.gnr_id as gnr_id,RI.item_id,RI.itm_id as item_code,RI.category_id FROM gnr_creation G inner join rejection_creation R on G.gnr_id=R.gnr_id inner join purchase_order_rejection RI on R.rejection_id=RI.rejection_id inner join item_creation I on I.item_id=RI.item_id WHERE R.rejection_date between '$from_date' and '$to_date' and RI.rejection_qty!=0";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Godown Transfer')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Godown-Transfer.csv";
			
			$query = "SELECT S.stk_tr_no,DATE_FORMAT(S.stk_tr_date, '%d-%m-%Y') as stk_tr_date,S.tr_time,S.frm_branchname as frm_branch,S.to_branchname as to_branch,SI.item_name,SI.uom,SI.quantity as tr_quantity,SI.price,SI.total_amount,SI.item_id,SI.itm_id as item_code,SI.category_id FROM stock_transfer S inner join stock_transfer_item SI on S.stk_tr_id=SI.stk_tr_id WHERE S.stk_tr_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Damage')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Damage.csv";
			
			$query = "SELECT D.damage_id,D.damage_no,DATE_FORMAT(D.damage_date, '%d-%m-%Y') as damage_date,D.dtime as time,D.branchname,DI.damage_order_id,DI.damage_item_name,DI.damage_uom as uom,DI.damage_qty,DI.item_id,IT.itm_id as item_code,DI.category_id from damage_order_creation D inner join damage_order_item DI on D.damage_id=DI.damage_id inner join item_creation IT on DI.item_id=IT.item_id where D.return_type IS NULL and (D.damage_date between '$from_date' and '$to_date')";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Direct Issue')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Direct-Issue.csv";
			
			$query = "SELECT i.issue_id,i.issue_no,DATE_FORMAT(i.issue_date, '%d-%m-%Y') as issue_date,i.issue_time,i.outlet_name,i.total,i.branchname,it.indent_item_name as item_name,it.indent_uom as uom,it.indent_qty as issued_qty,it.issues_price as rate,it.tax,it.tax_amount,it.basic_price as amount,it.total_amount as total_price,it.item_id,IM.itm_id as item_code,it.cat_id from issues_order_creation i inner join issues_order_item it on i.issue_id=it.issue_id inner join item_creation IM on it.item_id=IM.item_id where i.issue_date between '$from_date' and '$to_date' and i.request_id='0'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Indent')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Indent.csv";
			
			$query = "SELECT m.request_id,m.mat_req_no,DATE_FORMAT(m.request_date, '%d-%m-%Y') as request_date,m.request_time,m.store,m.branchname,mr.request_item_id,mr.item_name,mr.uom,mr.required_qty as requested_qty,mr.recieved_qty as issued_qty,mr.receipt_qty,mr.item_id,IT.itm_id as item_code,mr.category_id from material_request m inner join material_request_item mr on m.request_id=mr.request_id inner join item_creation IT on mr.item_id=IT.item_id where m.request_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Issue')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Issue.csv";
			
			$query = "SELECT i.issue_id,r.mat_req_no,i.issue_no,DATE_FORMAT(i.issue_date, '%d-%m-%Y') as issue_date,i.issue_time,i.outlet_name,i.total,i.branchname,i.request_id,i.user_name,it.indent_item_name as item_name,it.indent_uom as uom,it.indent_qty as issued_qty,it.issues_price as rate,it.tax,it.tax_amount,it.basic_price as amount,it.total_amount as total_price,it.request_item_id,it.item_id,IM.itm_id as item_code,mri.category_id from material_request r inner join issues_order_creation i on r.request_id=i.request_id inner join issues_order_item it on i.issue_id=it.issue_id inner join material_request_item mri on it.request_item_id=mri.request_item_id inner join item_creation IM on it.item_id=IM.item_id where i.issue_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Inward')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Inward.csv";
			
			$query = "SELECT MR.mat_req_no as request_no,DATE_FORMAT(MR.request_date, '%d-%m-%Y') as request_date,I.issue_no,DATE_FORMAT(I.issue_date, '%d-%m-%Y') as issue_date,R.req_rec_no,DATE_FORMAT(R.receipt_date, '%d-%m-%Y') as receipt_date,R.receipt_time,R.store,R.branchname,R.request_id,RP.receipt_item_id,mri.item_name,RP.quantity as received_qty,RP.req_rec_id,RP.requset_item_id,RP.item_id,IT.itm_id as item_code,mri.category_id from material_request MR inner join issues_order_creation I on MR.request_id=I.request_id inner join request_receipt R on I.issue_id=R.issue_id inner join request_receipt_item RP on R.req_rec_id=RP.req_rec_id inner join material_request_item mri on RP.requset_item_id=mri.request_item_id inner join item_creation IT on RP.item_id=IT.item_id where R.receipt_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Pride Inward')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Pride-Inward.csv";
			
			$query = "SELECT r.req_rec_no,r.receipt_time,r.store,DATE_FORMAT(r.receipt_date, '%d-%m-%Y') as receipt_date,r.branchname,r.request_id,rp.receipt_item_id,mri.item_name,mri.uom,rp.quantity as received_qty,rp.rc_item_price as price,rp.rc_tax as tax,rp.rc_tax_amount as tax_amount,rp.rc_total_price as total,rp.rc_total_amount as total_value,rp.req_rec_id,rp.requset_item_id,rp.item_id,IT.itm_id as item_code,rp.category_id from request_receipt r inner join request_receipt_item rp on r.req_rec_id=rp.req_rec_id inner join material_request_item mri on rp.requset_item_id=mri.request_item_id inner join item_creation IT on rp.item_id=IT.item_id where r.receipt_date between '$from_date' and '$to_date' and r.store='Pride Bakers'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Damage/Wastage')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Damage/Wastage.csv";
			
			$query = "SELECT D.damage_id,D.damage_no,DATE_FORMAT(D.damage_date, '%d-%m-%Y') as damage_date,D.dtime as time,D.return_type as type,D.branchname,DI.damage_order_id,DI.item_type,DI.damage_item_name,DI.damage_uom as uom,DI.damage_qty,DI.item_id,DI.category_id from damage_order_creation D inner join damage_order_item DI on D.damage_id=DI.damage_id where D.return_type IS NOT NULL and (D.damage_date between '$from_date' and '$to_date')";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Month End Stock')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Month-End-Stock.csv";
			
			$query = "SELECT S.branchname as Branch,DATE_FORMAT(S.stk_date, '%d-%m-%Y') as Date,S.stk_time as time,S.stock_no as Stock_Update_No,ST.item_type,ST.item_name as Product_Name,ST.uom as UOM,round(ST.rate,2) as rate,ST.present_stk as System_Stock,ST.closing_stk as Physical_Stock,(ST.present_stk-ST.closing_stk) as Difference,ST.cat_id as Cat_ID from stock_update S inner join stock_update_item ST on S.stck_id=ST.stck_id where S.stk_date between '$from_date' and '$to_date' and S.stock_no like 'S%'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Daily Stock Update')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Daily-Stock-Update.csv";
			
			$query = "SELECT S.stck_id,S.stock_no,DATE_FORMAT(S.stk_date, '%d-%m-%Y') as stk_date,S.stk_time as time,S.branchname,ST.stk_item_id,ST.item_type,ST.item_name,ST.uom,round(ST.rate,2) as rate,ST.present_stk as system_stock,ST.closing_stk,ST.item_id,ST.cat_id from stock_update S inner join stock_update_item ST on S.stck_id=ST.stck_id where S.stk_date between '$from_date' and '$to_date' and S.stock_no like 'D%'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Production')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Production.csv";
			
			//$query = "SELECT b.billno as production_id,b.bill_id as ref_no,bp.pr_cat_id,DATE_FORMAT(b.orderdate, '%d-%m-%Y') as orderdate,b.ordertime as time,b.chef,b.outlet as outlet,bp.pname as product_name,bp.uom,bp.yeild as projected_yeild,bp.actual_yeild,bp.billno as production_id from billdetails b inner join bom_product bp on b.billno=bp.billno where b.orderdate between '$from_date' and '$to_date'";
			
			$query = "SELECT b.billno as production_id,b.bill_id as ref_no,DATE_FORMAT(b.orderdate, '%d-%m-%Y') as orderdate,b.ordertime as time,b.pname as product_name,b.actual_yeild,b.actual_batch,b.chef,b.outlet as outlet,bp.iname as item_name,bp.iuom,bp.quantity,bp.price,bp.item_id,b.recipe_id from billdetails b inner join bproduct bp on b.billno=bp.billno where b.orderdate between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'PIndent')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "PIndent.csv";
			
			$query = "SELECT P.request_id,P.pr_req_no,DATE_FORMAT(P.request_date, '%d-%m-%Y') as request_date,P.request_time,P.dept,P.branchname,P.orders as order_type,PI.request_item_id,PI.item_name,PI.uom,PI.required_qty as requested_qty,PI.recieved_qty as issued_qty,PI.receipt_qty,PI.request_id,PI.pr_cat_id from product_request P inner join product_request_item PI on P.request_id=PI.request_id where P.request_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'PIssue')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "PIssue.csv";
			
			$query = "SELECT PI.issue_id,P.pr_req_no,PI.issue_no,DATE_FORMAT(PI.issue_date, '%d-%m-%Y') as issue_date,PI.issue_time,PI.outlet,PI.branchname,PI.request_id,PIT.issue_item_name as item_name,PIT.issue_uom as uom,PIT.issued_qty as issued_qty,PIT.price as rate,PIT.tax,PIT.tax_amount,PIT.basic_price as amount,PIT.total_price,PIT.issue_id,PIT.request_item_id,PRI.pr_cat_id from product_request P inner join product_issues_creation PI on P.request_id=PI.request_id inner join product_issues_item PIT on PI.issue_id=PIT.issue_id inner join product_request_item PRI on PIT.request_item_id=PRI.request_item_id where PI.issue_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'ProductIssue')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Product-Issue.csv";
			
			$query = "SELECT PI.issue_id,PI.issue_no,DATE_FORMAT(PI.issue_date, '%d-%m-%Y') as issue_date,PI.issue_time,PI.outlet,P.issue_item_name,P.issue_uom,P.issued_qty,P.price,P.basic_price,P.tax,P.tax_amount,P.total_price,P.recipe_id,P.recipe_no,P.pr_cat_id,PI.branchname,PI.issue_type from product_issues_creation PI inner join product_issues_item P on PI.issue_id=P.issue_id where PI.issue_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
			
			
		/*	$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Product_Issue.csv";
			
			$query = "SELECT PI.issue_id,PI.issue_no,DATE_FORMAT(PI.issue_date, '%d-%m-%Y') as issue_date,PI.issue_time,PI.outlet,P.issue_item_name,P.issue_uom,P.issued_qty,P.price,P.basic_price,P.tax,P.tax_amount,P.total_price,P.recipe_id,P.recipe_no,P.pr_cat_id,PI.branchname,PI.issue_type from product_issues_creation PI inner join product_issues_item P on PI.issue_id=P.issue_id where PI.issue_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);*/
		}
		else if($report_type == 'ProductIssueCW')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Product_Invoice_CW.csv";
			
			$query = "SELECT PI.issue_id,PI.issue_no,DATE_FORMAT(PI.issue_date, '%d-%m-%Y') as issue_date,PI.issue_time,PI.outlet,P.issue_item_name,P.issue_uom,P.issued_qty,P.price,P.basic_price,P.tax,P.tax_amount,P.total_price,P.recipe_id,P.recipe_no,P.pr_cat_id,PI.branchname from product_issues_creation PI inner join product_issues_item P on PI.issue_id=P.issue_id where PI.issue_date between '$from_date' and '$to_date' and PI.issue_type='Invoice'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'PInward')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "PInward.csv";
			
			$query = "SELECT PR.req_rec_no,DATE_FORMAT(PR.receipt_date, '%d-%m-%Y') as receipt_date,PR.receipt_time,PR.dept,PR.branchname,PR.request_id,PRI.receipt_item_id,PRI.item_name,PRI.quantity as received_qty,PRI.req_rec_id,PRI.request_item_id,PRIT.pr_cat_id from product_req_rec PR inner join product_req_rec_item PRI on PR.req_rec_id=PRI.req_rec_id inner join product_request_item PRIT on PRI.request_item_id=PRIT.request_item_id where PR.receipt_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Transfer')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Transfer.csv";
			
			$query = "SELECT T.tr_id,T.trans_no,DATE_FORMAT(T.trans_date, '%d-%m-%Y') as trans_date,T.trans_time,T.dept_name as to_dept,T.branchname,TI.tr_item_id,TI.item_type,TI.item_name,TI.uom,TI.quantity,TI.item_id,TI.cat_id from transfer T inner join transfer_item TI on T.tr_id=TI.tr_id where T.trans_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Transfer Inward')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Transfer-Inward.csv";
			
			$query = "SELECT TI.trans_in_no,DATE_FORMAT(TI.tr_in_date, '%d-%m-%Y') as tr_in_date,TI.in_time,TI.from_dept,TI.branchname,TI.tr_id,TIT.tr_in_item_id,TIT.item_type,TIT.item_name,TIT.quantity as received_qty,TIT.tr_in_id,TIT.tr_item_id,TIT.item_id,TIT.cat_id from transfer_inward TI inner join transfer_inward_item TIT on TI.tr_in_id=TIT.tr_in_id where TI.tr_in_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Raw Material')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Raw-Material.csv";
			
		//	$query = "SELECT I.itm_id as item_id,I.item_name,I.category_id,C.category_name,I.uom,DATE_FORMAT(I.creation_date, '%d-%m-%Y') as creation_date FROM item I inner join category C on C.category_id=I.category_id where I.active_status='active' order by I.itm_id desc";
			$query = "SELECT I.itm_id as item_id,I.item_name,I.category_id,C.category_name,I.uom,DATE_FORMAT(I.creation_date, '%d-%m-%Y') as creation_date FROM item I inner join category C on C.category_id=I.category_id order by I.itm_id asc";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'CMS_Products')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "CMS_Products.csv";
			
			$query = "SELECT R.rname as product_name,R.uom,R.cw_price as price,R.cw_tax as tax,R.cw_tax_amount as tax_amount,R.cw_total_price as total_price,C.pr_cat_id as cat_id,C.pr_cat_name as cat_name from recipe R inner join product_category C on R.pr_cat_id=C.pr_cat_id where R.cw_price!='0' and R.branchname='CMS'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Raw Material Stock')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Raw-Material-Stock.csv";
			
			$query = "select c.category_name,i.item_name,i.uom,i.item_price,i.item_tax,i.avg_price,i.vendor_name,st.closing_stock,(i.item_price*st.closing_stock) as total from (select * from category) c inner join (select item_name,uom,item_price,item_tax,avg_price,vendor_name,category_id from item_creation where branchname='$branch' and status='Enabled') i on c.category_id=i.category_id inner join (select * from stock_detail where branchname='$branch') st on i.item_name=st.item_name inner join (select item_name,transaction_date,closing_stock,MAX(last_modified) as maxdate from stock_detail where branchname='$branch' and transaction_date <= '$to_date' group by item_name) stk on st.item_name=stk.item_name and st.last_modified=stk.maxdate";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Product Stock')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Product-Stock.csv";
			
			$query = "select c.pr_cat_name as category,i.rname as product_name,i.uom,i.recipe_price as price,st.closing_stock,(i.recipe_price*st.closing_stock) as total from (select * from product_category) c inner join (select recipe_no,rname,uom,recipe_price,pr_cat_id from recipe where branchname='$branch' and status='Enabled') i on c.pr_cat_id=i.pr_cat_id inner join (select * from stock_detail) st on i.recipe_no=st.recipe_no inner join (select item_name,recipe_no,transaction_date,closing_stock,MAX(last_modified) as maxdate from stock_detail where branchname='$branch' and transaction_date <= '$to_date' group by recipe_no) stk on st.recipe_no=stk.recipe_no and st.last_modified=stk.maxdate";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Store Invoice')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Store-Invoice.csv";
			
			$query = "SELECT PI.issue_id as inv_id,PI.invoice_no,DATE_FORMAT(PI.issue_date, '%d-%m-%Y') as invoice_date,PI.issue_time as invoice_time,PI.outlet,PI.branchname,PIT.issue_item_name as item_name,PIT.issue_uom as uom,PIT.issued_qty as qty,PIT.price as rate,PIT.tax,PIT.tax_amount,PIT.basic_price as amount,PIT.total_price,PIT.issue_id as invoice_id,PIT.pr_cat_id from product_issues_creation PI inner join product_issues_item PIT on PI.issue_id=PIT.issue_id where PI.issue_date between '$from_date' and '$to_date' and PI.invoice_no!=''";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Raw Material Invoice')
		{
			$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Raw-Material-Invoice.csv";
			
			$query = "SELECT PI.invoice_id as inv_id,PI.invoice_no,DATE_FORMAT(PI.invoice_date, '%d-%m-%Y') as invoice_date,PI.invoice_time as invoice_time,PI.outlet_name,PI.branchname,PIT.item_name as item_name,PIT.uom as uom,PIT.required_qty as qty,PIT.item_price as rate,PIT.tax,PIT.tax_amount,(PIT.item_price*PIT.required_qty) as amount,PIT.total_amount as total_price,PIT.invoice_id as invoice_id,PIT.category_id from invoice PI inner join invoice_item PIT on PI.invoice_id=PIT.invoice_id where PI.invoice_date between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'A Production'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Actual-Production.csv";
		//	$query = "SELECT S.stck_id,S.stock_no,DATE_FORMAT(S.stk_date, '%d-%m-%Y') as stk_date,S.branchname,ST.stk_item_id,ST.item_type,ST.item_name,ST.uom,ST.closing_stk as production_stk,ST.stck_id,ST.item_id,S.branchname from stock_update S inner join stock_update_item ST on S.stck_id=ST.stck_id where S.stk_date between '$from_date' and '$to_date' and S.branchname='BOM' and S.stock_no like 'A%'"
			$query = "SELECT S.stck_id,S.stock_no,DATE_FORMAT(S.stk_date, '%d-%m-%Y') as stk_date,ST.stk_item_id,ST.item_type,ST.item_name,ST.uom,ST.closing_stk as production_stk,ST.item_id,S.branchname from stock_update S inner join stock_update_item ST on S.stck_id=ST.stck_id where S.stk_date between '$from_date' and '$to_date'  and S.stock_no like 'A%'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Raw Material Consumption - BOM'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Raw-Material-BOM.csv";
			
			$query = "SELECT b.billno as production_id,b.bill_id as ref_no,b.pr_cat_id,DATE_FORMAT(b.orderdate, '%d-%m-%Y') as orderdate,b.chef,b.actual_yeild,b.pname as product,bp.iname as product_name,bp.quantity as quantity,bp.price as price,b.outlet from billdetails b inner join bproduct bp on b.billno=bp.billno where b.orderdate between '$from_date' and '$to_date'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'BOM'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Raw-Material-BOM.csv";
			
			$query = "SELECT b.billno as production_id,b.bill_id as ref_no,b.pr_cat_id,DATE_FORMAT(b.orderdate, '%d-%m-%Y') as orderdate,b.chef,b.actual_yeild as yeild,b.actual_batch as batch,b.pname as product,bp.iname as product_name,bp.quantity as quantity,bp.price as price,b.outlet from billdetails b inner join bproduct bp on b.billno=bp.billno  where b.orderdate between '$from_date' and '$to_date' and b.branch_id='3'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Product_List'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Product_List.csv";
			
			$query = "SELECT `recipe_id`, `recipe_no`, `hsn_code`, `raised_date`, `rname`, `f_code`, `yeild`, `uom`, `recipe_price`, `production_stock`, `product_image`, `raised_on`, `od_time`, `shelf_life`, `spl_ord`, `food_delivery`, `prepared_by`, `status_effective`, `recipe_cat`, `flavour`, `sqcode`, `status`, `aprvl_status`, `pr_cat_id`, `branchname`, `branch_id` FROM `recipe` where branch_id='2'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Recipe'){
		    /*$this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Recipe.csv";
			
			$query = "SELECT r.`recipe_id`, r.`recipe_no`, r.`hsn_code`, r.`raised_date`, r.`rname`, r.`f_code`, r.`yeild`, r.`uom`, r.`recipe_price`, r.`production_stock`, r.`product_image`, r.`raised_on`, r.`od_time`, r.`shelf_life`, r.`spl_ord`, r.`food_delivery`, r.`prepared_by`, r.`status_effective`, r.`recipe_cat`, r.`flavour`, r.`sqcode`, r.`status`, r.`aprvl_status`, r.`pr_cat_id`, r.`branchname`, r.`branch_id`,ri.`rc_item_id`, ri.`item_name`, ri.`qty`, ri.`price`, ri.`total`, ri.`item_id`, ri.`category_id` FROM `recipe` r inner join recipe_item ri on r.recipe_id=ri.recipe_id where r.branch_id='2'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);*/
			
			$fileName = 'data-'.time().'.xlsx';
    		// load excel library
    		$this->load->library('excel');
    		$listInfo = $this->user_model->getrecipeDetail();
    		$listInfo2 = $this->user_model->getsubrecipeDetail();
    		$objPHPExcel = new PHPExcel();
    		$objPHPExcel->setActiveSheetIndex(0);
    		// set Header
    			
    		// set Row
    		$rowCount = 0;
    					
    		$rowCount = $rowCount + 1;
    		$objPHPExcel->getActiveSheet()->SetCellValue('A' . $rowCount, 'Recipe Id');
    		$objPHPExcel->getActiveSheet()->SetCellValue('B' . $rowCount, 'Product Name');
    		$objPHPExcel->getActiveSheet()->SetCellValue('C' . $rowCount, 'UOM');
    		$objPHPExcel->getActiveSheet()->SetCellValue('D' . $rowCount, 'Yield');
    		$objPHPExcel->getActiveSheet()->SetCellValue('E' . $rowCount, 'Product Category Id');
    		$objPHPExcel->getActiveSheet()->SetCellValue('F' . $rowCount, 'Branch Name');
    		$objPHPExcel->getActiveSheet()->SetCellValue('G' . $rowCount, 'Recipe Item Id');
    		$objPHPExcel->getActiveSheet()->SetCellValue('H' . $rowCount, 'Item Name');
    		$objPHPExcel->getActiveSheet()->SetCellValue('I' . $rowCount, 'UnitOM');
    		$objPHPExcel->getActiveSheet()->SetCellValue('J' . $rowCount, 'Qty');		
    		$objPHPExcel->getActiveSheet()->SetCellValue('K' . $rowCount, 'Price');
    		$objPHPExcel->getActiveSheet()->SetCellValue('L' . $rowCount, 'Total Amount');
    		$objPHPExcel->getActiveSheet()->SetCellValue('M' . $rowCount, 'Item Id');
    		$objPHPExcel->getActiveSheet()->SetCellValue('N' . $rowCount, 'Category Id');
    		
    		$rowCount1 = $rowCount + 1;
    		foreach ($listInfo as $list1) {
    			$objPHPExcel->getActiveSheet()->SetCellValue('A' . $rowCount1, $list1->recipe_id);
    			$objPHPExcel->getActiveSheet()->SetCellValue('B' . $rowCount1, $list1->rname);
    			$objPHPExcel->getActiveSheet()->SetCellValue('C' . $rowCount1, $list1->uom);
    			$objPHPExcel->getActiveSheet()->SetCellValue('D' . $rowCount1, $list1->yeild);
    			$objPHPExcel->getActiveSheet()->SetCellValue('E' . $rowCount1, $list1->pr_cat_id);
    			$objPHPExcel->getActiveSheet()->SetCellValue('F' . $rowCount1, $list1->branchname);
    			$objPHPExcel->getActiveSheet()->SetCellValue('G' . $rowCount1, $list1->rc_item_id);
    			$objPHPExcel->getActiveSheet()->SetCellValue('H' . $rowCount1, $list1->item_name);
    			$objPHPExcel->getActiveSheet()->SetCellValue('I' . $rowCount1, $list1->uoms);
    			$objPHPExcel->getActiveSheet()->SetCellValue('J' . $rowCount1, $list1->qty);
    			$objPHPExcel->getActiveSheet()->SetCellValue('K' . $rowCount1, $list1->basicPrice);
    			$objPHPExcel->getActiveSheet()->SetCellValue('L' . $rowCount1, $list1->totalA);
    			$objPHPExcel->getActiveSheet()->SetCellValue('M' . $rowCount1, $list1->item_ids);
    			$objPHPExcel->getActiveSheet()->SetCellValue('N' . $rowCount1, $list1->category_ids);
    			$rowCount1++;
    		}
    		$rowCount2 = $rowCount1 + 0;
    		foreach ($listInfo2 as $list2) {
    			$objPHPExcel->getActiveSheet()->SetCellValue('A' . $rowCount2, $list2->recipe_id);
    			$objPHPExcel->getActiveSheet()->SetCellValue('B' . $rowCount2, $list2->rname);
    			$objPHPExcel->getActiveSheet()->SetCellValue('C' . $rowCount2, $list2->uom);
    			$objPHPExcel->getActiveSheet()->SetCellValue('D' . $rowCount2, $list2->yeild);
    			$objPHPExcel->getActiveSheet()->SetCellValue('E' . $rowCount2, $list2->pr_cat_id);
    			$objPHPExcel->getActiveSheet()->SetCellValue('F' . $rowCount2, $list2->branchname);
    			$objPHPExcel->getActiveSheet()->SetCellValue('G' . $rowCount2, $list2->rc_item_id);
    			$objPHPExcel->getActiveSheet()->SetCellValue('H' . $rowCount2, $list2->item_name);
    			$objPHPExcel->getActiveSheet()->SetCellValue('I' . $rowCount2, $list2->uoms);
    			$objPHPExcel->getActiveSheet()->SetCellValue('J' . $rowCount2, $list2->qty);
    			$objPHPExcel->getActiveSheet()->SetCellValue('K' . $rowCount2, $list2->basicPrice);
    			$objPHPExcel->getActiveSheet()->SetCellValue('L' . $rowCount2, $list2->totalA);
    			$objPHPExcel->getActiveSheet()->SetCellValue('M' . $rowCount2, $list2->item_ids);
    			$objPHPExcel->getActiveSheet()->SetCellValue('N' . $rowCount2, $list2->category_ids);
    			$rowCount2++;
    		}	
    		
    	
    				
    		$filename = "Recipe-Detail". date("d-m-Y").".csv";
    		header('Content-Type: application/vnd.ms-excel'); 
    		header('Content-Disposition: attachment;filename="'.$filename.'"');
    		header('Cache-Control: max-age=0'); 
    		$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'CSV');  
    		$objWriter->save('php://output'); 
		}
		else if($report_type == 'dc_price'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "DC Price.csv";
			
			$query = "SELECT o.`outlet_item_id`, o.`item_name`, o.`price`, o.`tax`, o.`basic_price`, o.`tax_amt`, o.`total_amt`, r.`branchname`, o.`recipe_no`, o.`recipe_id` FROM `outlet_item_price` o inner join recipe r on o.`outlet_id`=r.branch_id and r.`recipe_id`=o.`recipe_id`";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'tmdc_price'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "TM DC Price.csv";
			
			$query = "SELECT `recipe_id`, `recipe_no`, `rname`, `f_code`, `yeild`, `uom`, `cw_price` as prcie, `cw_tax` as tax, `cw_tax_amount` as tax_amt, `cw_total_price` as total, `pr_cat_id`, `branchname`, `branch_id` FROM `recipe` WHERE branchname='TM1'";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'RM Category'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "RM-Category.csv";
			
			$query = "SELECT `category_id`, `category_name` FROM `category`";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
		else if($report_type == 'Product Category'){
		    $this->load->dbutil();
			$this->load->helper('file');
			$this->load->helper('download');
			$delimiter = ",";
			$newline = "\r\n";
			$filename = "Product-Category.csv";
			
			$query = "SELECT `pr_cat_id`, `pr_cat_name` FROM `product_category`";
			$result = $this->db->query($query);
			$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
			force_download($filename, $data);
		}
	}
}
?>