<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Issues extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->model('user_model');
		$this->load->model('master_model');
		$this->load->model('report_model');
		$this->load->model('issue_model');
		
		if(!isset($_SESSION['user_logged'])) {
			$this->session->set_flashdata("error", "please login first to view dashboard");
			redirect("Login/login");
		}
	}
	var $master_url='https://taazamithai.com/inventory';
	public function issueEntry()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['category'] = $this->master_model->getCategory();
		$data['tax'] = $this->master_model->get_Tax();
		$data['items'] = $this->master_model->get_Items($branch_id);
		$this->load->view('Issues/isuue_entry',$data);
	}
	
	public function addIssue()
	{
		$isid=$this->issue_model->addIssue($this->input->post());
		redirect('Issues/issueView/'.$isid);
	}
	
	public function issueView($isid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->issue_model->getIssue($isid);
		$data['issue_item'] = $this->issue_model->getIssueItem($isid);
		$data['issue_item_total'] = $this->issue_model->getIssueItemTotal($isid);
		$this->load->view('Issues/issue_view',$data);
	}
	
	public function issuetList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue_list'] = $this->issue_model->getIssueList($branch_id);
		$this->load->view('Issues/issue_list',$data);
	}

	public function cissuetList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue_list'] = $this->issue_model->getAllIssueList($branch_id);
		$this->load->view('Issues/cissue_list',$data);
	}

	public function cissueView($isid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->issue_model->getIssue($isid);
		$data['issue_item'] = $this->issue_model->getIssueItem($isid);
		$this->load->view('Issues/cissue_view',$data);
	}
	
	public function productIssueEntry()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['category'] = $this->master_model->getCategory();
		$data['tax'] = $this->master_model->get_Tax();
		$data['items'] = $this->issue_model->get_Products($branch_id);
		$this->load->view('Issues/productIssueEntry',$data);
	}
	
	public function get_ProductDetails()
	{
		$iname = $this->input->post('iname');
		$br_id = $this->input->post('br_id');
		$this->issue_model->get_ProductDetails($iname,$br_id);
	}
	
	public function get_ProductDetailsNew()
	{
		$iname = $this->input->post('iname');
		$br_id = $this->input->post('br_id');
		$this->issue_model->get_ProductDetailsNew($iname,$br_id);
	}
	
	
	public function addPrIssue()
	{
		$isid=$this->issue_model->addPrIssue($this->input->post());
		redirect('Issues/issuePrView/'.$isid);
	}
	
	public function issuePrView($isid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->issue_model->getPrIssue($isid);
		$data['issue_item'] = $this->issue_model->getPrIssueItem($isid);
		$this->load->view('Issues/issue_Prview',$data);
	}
	
	public function issuePrList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue_list'] = $this->issue_model->issuePrList($branch_id);
		$this->load->view('Issues/issue_Prlist',$data);
	}
	
	public function issue_PrList(){
		
		$branch_id = $_SESSION['branch_id'];
		$data = $this->issue_model->issuePrList($branch_id);
        $count=1;
        $test = array();
        foreach($data as $row)
    	{
    	    
    	    $view = "<a href='$this->master_url/index.php/Issues/issuePrView/$row->issue_id' class='btn btn-sm btn-primary'><i class='la la-eye '> </i></a>";
    	    
    	    
    	    $test[] = array(
    	        $count,
    	        $row->issue_no,
    	        $row->issue_date,
    	        $row->outlet,
                $view
    	   );
    	        
    	        $count++;
    	}
    	$datas = array(
    	    "data" =>$test
    	);
    	
    	echo json_encode($datas);
	}
	
	public function productInvoiceEntry()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['category'] = $this->master_model->getCategory();
		$data['tax'] = $this->master_model->get_Tax();
		$data['items'] = $this->issue_model->get_Products($branch_id);
		$this->load->view('Issues/productInvoiceEntry',$data);
	}
	
	public function get_OutletProductDetails()
	{
		$iname = $this->input->post('iname');
		$br_id = $this->input->post('br_id');
		$out_id=$this->input->post('out_id');
		$this->issue_model->get_OutletProductDetails($iname,$br_id,$out_id);
	}
	
	public function addPrInvoice()
	{
		$isid=$this->issue_model->addPrInvoice($this->input->post());
		redirect('Issues/issuePrInvoiceView/'.$isid);
	}
	
	public function vendor_product()  
   {  
	  //set selected country id from POST  
	  echo $outlet_id = $this->input->post('id',TRUE);  
	  //run the query for the cities we specified earlier  
	  $productData['product']=$this->issue_model->get_seller_product($outlet_id);  
	  $output = null;  
	  $output .= "<option value=''>Select</option>";
	  foreach ($productData['product'] as $row)  
	  {  
		 //here we build a dropdown item line for each   query result  
		 $output .= "<option value='".$row->product_name."'>".$row->product_name."</option>";  
	  }  
	  echo $output;  
   }
   
   public function issuePrInvoiceView($isid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->issue_model->getPrIssue($isid);
		$data['issue_item'] = $this->issue_model->getPrIssueItem($isid);
		$this->load->view('Issues/issue_PrInvoiceview',$data);
	}
	
	public function invoicePrList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue_list'] = $this->issue_model->invoicePrList($branch_id);
		$this->load->view('Issues/invoice_Prlist',$data);
	}
}