<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Maintainance extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->model('user_model');
		$this->load->model('master_model');
		$this->load->model('report_model');
		$this->load->model('maintain_model');
		
		if(!isset($_SESSION['user_logged'])) {
			$this->session->set_flashdata("error", "please login first to view dashboard");
			redirect("Login/login");
		}
	}	
	var $master_url='https://taazamithai.com/inventory';
	public function maintainance_grn()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['tax'] = $this->master_model->get_Tax();
		$data['vendor'] = $this->maintain_model->get_vendor();
		$this->load->view('Maintainance/maintainance_grn',$data);
	}
	
	
	public function addMaintainance()
	{
		$grn_id=$this->maintain_model->addMaintainance($this->input->post());
		redirect('Maintainance/maintainance_invoice/'.$grn_id);
		
	}
	
	public function maintainance_invoice($grn_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mnt_grn'] = $this->maintain_model->get_mnt_grn($grn_id);
		$data['mnt_grn_item'] = $this->maintain_model->get_mnt_grn_item($grn_id);
		$data['mnt_grn_total_sum'] = $this->maintain_model->mnt_grn_total_sum($grn_id);
		$this->load->view('Maintainance/preview_maintainance',$data);
		
	}
	public function mnt_grn_list(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$sub_mod_id = $this->uri->segment(3);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$data['maintainance_grn'] = $this->maintain_model->mnt_grn_list($branch_id);
		$this->load->view('Maintainance/mnt_grn_list',$data);	
	}
	
	
	public function maintainance_view($grn_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$sub_mod_id = $this->uri->segment(4);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$data['mnt_grn'] = $this->maintain_model->get_mnt_grn($grn_id);
		$data['mnt_grn_item'] = $this->maintain_model->get_mnt_grn_item($grn_id);
		$data['mnt_grn_total_sum'] = $this->maintain_model->mnt_grn_total_sum($grn_id);
		$this->load->view('Maintainance/maintainance_view',$data);
		
	}
	
	public function mnt_stock(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mnt_stock'] = $this->maintain_model->mnt_stock($branch_id);
		$this->load->view('Maintainance/mnt_stock',$data);	
	}
	
	public function cmnt_grn_list(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$sub_mod_id = $this->uri->segment(3);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$data['maintainance_grn'] = $this->maintain_model->cmnt_grn_list();
		$this->load->view('Maintainance/ceo_mnt_grn_list',$data);	
	}
}