<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class MaterialRequest extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->model('user_model');
		$this->load->model('master_model');
		$this->load->model('report_model');
		$this->load->model('materialrequest_model');
		
		if(!isset($_SESSION['user_logged'])) {
			$this->session->set_flashdata("error", "please login first to view dashboard");
			redirect("Login/login");
		}
	}
	
	public function materialRequest()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$sub_mod_id = $this->uri->segment(3);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['category'] = $this->master_model->getCategory();
		$data['tax'] = $this->master_model->get_Tax();
		$data['items'] = $this->master_model->get_Items($branch_id);
		$data['store'] = $this->materialrequest_model->getStore($sub_mod_id,$branch_id);
		$this->load->view('MaterialRequest/material_request',$data);
	}
	
	public function addRequest()
	{
		$rid=$this->materialrequest_model->addRequest($this->input->post());
		redirect('MaterialRequest/requestView/'.$rid);
	}
	
	public function requestView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequest($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/request_view',$data);
	}
	
	public function requestList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getRequestList($branch_id);
		$this->load->view('MaterialRequest/request_list',$data);
	}
	
	public function reqView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequest($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/req_view',$data);
	}
	
	public function editRequest($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['category'] = $this->master_model->getCategory();
		$data['tax'] = $this->master_model->get_Tax();
		$data['items'] = $this->master_model->get_Items($branch_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequest($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/edit_request',$data);
	}
	
	public function updateRequest()
	{
		$rid=$this->materialrequest_model->updateRequest($this->input->post());
		redirect('MaterialRequest/reqView/'.$rid);
	}
	
	public function issuePendingList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getIssuePendingList($uname);
		$this->load->view('MaterialRequest/issue_pending_list',$data);
	}
	
	public function strreqView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequestIss($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/strreq_view',$data);
	}
	
	public function requestIssue($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequestIss($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestIssItem($rid);
		$this->load->view('MaterialRequest/item_issue',$data);
	}
	
	public function addIssue()
	{
		$isid=$this->materialrequest_model->addIssue($this->input->post());
		redirect('MaterialRequest/issueView/'.$isid);
	}
	
	public function issueView($isid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->materialrequest_model->getIssue($isid);
		$data['issue_item'] = $this->materialrequest_model->getIssueItem($isid);
		$this->load->view('MaterialRequest/issue_view',$data);
	}
	
	public function requestRmkUpdate(){
		$req_id = $this->input->post('req_id');
		$req_remark = $this->input->post('req_remark');
		$this->db->query("update material_request set status='Closed',remark='$req_remark' where request_id='$req_id'");
		echo 1;
	}
	
	public function requestRmkissUpdate(){
		$req_id = $this->input->post('req_id');
		$req_remark = $this->input->post('req_remark');
		$this->db->query("update material_request set receipt_status='Closed',issue_remark='$req_remark' where request_id='$req_id'");
		echo 1;
	}
	
	public function requestIssueList($req_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getRequesIssuetList($req_id);
		$data['req_iss_list'] = $this->materialrequest_model->getRequesIssuetLists($req_id);
		$this->load->view('MaterialRequest/request_issue_list',$data);
	}
	
	public function issueInward($req_id,$issue_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->materialrequest_model->getIssue($issue_id);
		$data['issue_item'] = $this->materialrequest_model->getIssuedItem($issue_id);
		$this->load->view('MaterialRequest/issue_inward',$data); 
	}
	
	public function addInward()
	{
		$inid=$this->materialrequest_model->addInward($this->input->post());
		redirect('MaterialRequest/inwardView/'.$inid);
	}
	
	public function inwardView($inid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['inward'] = $this->materialrequest_model->getInward($inid);
		$data['inward_item'] = $this->materialrequest_model->getInwardItem($inid);
		$this->load->view('MaterialRequest/inward_view',$data);
	}
	
	public function prideInward($req_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req'] = $this->materialrequest_model->getMatRequest($req_id);
		$data['req_item'] = $this->materialrequest_model->getMatReqItem($req_id);
		$this->load->view('MaterialRequest/pride_inward',$data);
	}
	
	public function addPrideInward()
	{
		$inid=$this->materialrequest_model->addPrideInward($this->input->post());
		redirect('MaterialRequest/inwardPrideView/'.$inid);
	}
	
	public function inwardPrideView($inid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['inward'] = $this->materialrequest_model->getPrideInward($inid);
		$data['inward_item'] = $this->materialrequest_model->getPrideInwardItem($inid);
		$data['inward_rmk'] = $this->materialrequest_model->getPrideInwardRemark($inid);
		$data['dc_up'] = $this->materialrequest_model->getDcUpload($inid);
		$this->load->view('MaterialRequest/pride_inward_view',$data);
	}
	
	public function inwardTicket()
	{
		$this->materialrequest_model->addinwardTicket($this->input->post());
		$inid = $this->input->post('inw_id');
		redirect('MaterialRequest/inwardPrideView/'.$inid);
	}
	
	public function dcUpload()
	{
		$this->materialrequest_model->addDcUpload($this->input->post());
		$inid = $this->input->post('rcp_id');
		redirect('MaterialRequest/inwardPrideView/'.$inid);
	}
	
	public function requestClosedList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getRequestClosedList($branch_id);
		$this->load->view('MaterialRequest/request_closed_list',$data);
	}
	
	public function reqCloseView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequest($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/req_close_view',$data);
	}
	
	public function reqClosedView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_rec'] = $this->materialrequest_model->getMatReceipt($rid);
		$this->load->view('MaterialRequest/req_closed_view',$data);
	}
	
	public function req_single_recipt(){
		$rc_id = $_POST['rc_id'];
		$data['inward'] = $this->materialrequest_model->getInward($rc_id);
		$data['inward_item'] = $this->materialrequest_model->getInwardItem($rc_id);
		$this->load->view('MaterialRequest/rc_single_view', $data);
	}
	
	public function prideReqClosedView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_rec'] = $this->materialrequest_model->getPrideMatReceipt($rid);
		$this->load->view('MaterialRequest/pride_req_closed_view',$data);
	}
	
	public function preq_single_recipt(){
		$rc_id = $_POST['rc_id'];
		$data['inward'] = $this->materialrequest_model->getPrideInward($rc_id);
		$data['inward_item'] = $this->materialrequest_model->getPrideInwardItem($rc_id);
		$this->load->view('MaterialRequest/prc_single_view', $data);
	}
	
	public function receiptList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['rec_list'] = $this->materialrequest_model->getReceiptList($branch_id);
		$this->load->view('MaterialRequest/receipt_list',$data);
	}
	
	public function prideReceiptList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['rec_list'] = $this->materialrequest_model->getPrideReceiptList($branch_id);
		$this->load->view('MaterialRequest/pride_receipt_list',$data);
	}
	
	public function issueClosedList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue_list'] = $this->materialrequest_model->getIssueClosedList($uname);
		$this->load->view('MaterialRequest/issue_closed_list',$data);
	}
	
	public function strrequestView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequestIss($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/strrequest_view',$data);
	}
	
	public function issueClosedView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_iss'] = $this->materialrequest_model->getMatIssues($rid);
		$this->load->view('MaterialRequest/issue_closed_view',$data);
	}
	
	public function issue_single_recipt(){
		$is_id = $_POST['is_id'];
		$data['issue'] = $this->materialrequest_model->getIssue($is_id);
		$data['issue_item'] = $this->materialrequest_model->getIssueItem($is_id);
		$this->load->view('MaterialRequest/iss_single_view', $data);
	}
	
	public function issuetList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue_list'] = $this->materialrequest_model->getIssueList($branch_id);
		$this->load->view('MaterialRequest/issue_list',$data);
	}
	
	public function rejection($rcid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['receipt'] = $this->materialrequest_model->getrjReceipt($rcid);
		$data['receipt_item'] = $this->materialrequest_model->getrjReceiptItem($rcid);
		$this->load->view('MaterialRequest/rejection',$data);
	}
	
	public function addRejection()
	{
		$rjid=$this->materialrequest_model->addRejection($this->input->post());
		redirect('MaterialRequest/rejectionView/'.$rjid);
	}
	
	public function rejectionView($rjid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['rjn'] = $this->materialrequest_model->getRejection($rjid);
		$data['rjn_item'] = $this->materialrequest_model->getRejectionItem($rjid);
		$this->load->view('MaterialRequest/rejection_view',$data);
	}
	
	public function rejectionList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['rjn_list'] = $this->materialrequest_model->getRejectionList($branch_id);
		$this->load->view('MaterialRequest/rejection_list',$data);
	}
	
	public function inwardRemark()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['inw_rmk'] = $this->materialrequest_model->getInwardTicket($branch_id);
		$this->load->view('MaterialRequest/inward_ticket',$data);
	}
	
	public function reqPrdPendingList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getIssuePendingList($uname);
		$this->load->view('MaterialRequest/prdreq_pending_list',$data);
	}
	
	public function prdreqView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getMatRequestIss($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/prdreq_view',$data);
	}
	
	public function approveReq()
	{
		$req_id = $this->input->post('req_id');
		$apporval_date = date("Y-m-d");
		$query = $this->db->query("update material_request set status='Approved',approval_date='$apporval_date' where request_id='$req_id'");
		redirect('MaterialRequest/reqPrdPendingList/');
	}
	
	//ceo
	public function issueRequestOList(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getRequestIssueList();
		$this->load->view('MaterialRequest/issueRequestOList',$data);

	}

	public function issueCClosedList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getCRequestClosedList();
		$this->load->view('MaterialRequest/issueRequestClosedList',$data);
	}


	public function issuesCList($sub_mod_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['submod_id']=$sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['branch'] = $this->user_model->get_branch();
		//$data['issue_list'] = $this->materialrequest_model->getCIssueList();
		$this->load->view('MaterialRequest/issuesCList',$data);
	}

	public function getCIssueList()
	{
		$postdata = file_get_contents("php://input");
		$request = json_decode($postdata);
		$row = $request->row;
		$rowperpage = $request->rowperpage;
		$item_data = $this->materialrequest_model->getCIssueList($row,$rowperpage);
		foreach ($item_data as $item) 
		{ 
			$data[] = array(
			"issue_no"=>$item->issue_no,
			"issue_date"=>$item->issue_date,
			"outlet_name"=>$item->outlet_name,
			"total"=>$item->total,
			"mid"=>$item->mid
			);
		} 
		echo json_encode($data);
	}

	public function searchCissueList(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$branch = $this->input->post('branch');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch' =>$branch
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
			} else {
			$result = $this->materialrequest_model->getIssueListReport($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['branch'] = $this->user_model->get_branch();
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('MaterialRequest/issuesCList',$data);
	}

	public function exportIssueReport()
	{
		$from_date = date('Y-m-d',strtotime($this->input->post('from_date')));;
		$to_date = date('Y-m-d',strtotime($this->input->post('to_date')));
		$branchn = $this->input->post('branchn');
		$this->load->dbutil();
		$this->load->helper('file');
		$this->load->helper('download');
		$delimiter = ",";
		$newline = "\r\n";
		
		$filename = "Issue_Report.csv";
		$query = "SELECT *,issue_id as mid, DATE_FORMAT(issue_date, '%d-%m-%Y') as issue_date FROM issues_order_creation where issue_date between '$from_date' and '$to_date' and branchname='$branchn' ORDER BY issue_id desc";
		$result = $this->db->query($query);
		$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
		force_download($filename, $data);
	}

	//Pride Bakers issue list
	public function prideCList($sub_mod_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['submod_id']=$sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['branch'] = $this->user_model->get_branch();
		$data['pissue_list'] = $this->materialrequest_model->getCPrideIssueList();
		$this->load->view('MaterialRequest/prideCList',$data);
	}

	public function searchCPrideissueList(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$branch = $this->input->post('branch');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch' =>$branch
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
			} else {
			$result = $this->materialrequest_model->getPrideIssueListReport($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['branch'] = $this->user_model->get_branch();
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('MaterialRequest/prideCList',$data);
	}

	public function exportPIssueReport(){
		$from_date = date('Y-m-d',strtotime($this->input->post('from_date')));;
		$to_date = date('Y-m-d',strtotime($this->input->post('to_date')));
		$branchn = $this->input->post('branchn');
		$this->load->dbutil();
		$this->load->helper('file');
		$this->load->helper('download');
		$delimiter = ",";
		$newline = "\r\n";
		
		$filename = "Pride_Issue_Report.csv";
		if($outlet_name == 'All')
		{
			$query = "SELECT R.req_rec_no,DATE_FORMAT(R.receipt_date, '%d-%m-%Y') as receipt_date,R.receipt_approval as status,round(sum(RI.rc_total_amount),2) as total FROM request_receipt_item RI inner join request_receipt R on RI.req_rec_id=R.req_rec_id where R.store='Pride Bakers' and (R.receipt_date between '$from_date' and '$to_date') and R.branchname NOT LIKE 'CW4%' group by RI.req_rec_id";
			
		}
		else if($outlet_name == 'cw4_out') {
		    $query = "SELECT R.req_rec_no,DATE_FORMAT(R.receipt_date, '%d-%m-%Y') as receipt_date,R.receipt_approval as status,round(sum(RI.rc_total_amount),2) as total FROM request_receipt_item RI inner join request_receipt R on RI.req_rec_id=R.req_rec_id where R.store='Pride Bakers' and (R.receipt_date between '$from_date' and '$to_date') and R.branchname LIKE 'CW4%' group by RI.req_rec_id";
			
		}
		else
		{
			$query = "SELECT R.req_rec_no,DATE_FORMAT(R.receipt_date, '%d-%m-%Y') as receipt_date,R.receipt_approval as status,round(sum(RI.rc_total_amount),2) as total FROM request_receipt_item RI inner join request_receipt R on RI.req_rec_id=R.req_rec_id where R.store='Pride Bakers' and R.branchname='$outlet_name' and (R.receipt_date between '$from_date' and '$to_date') group by RI.req_rec_id";
			
		}
		$result = $this->db->query($query);
		$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
		force_download($filename, $data);
	}
	
	public function prIissueClosedList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->materialrequest_model->getIssueClosedList($uname);
		$this->load->view('MaterialRequest/prdreq_closed_list',$data);
	}
	
	public function prreqCloseView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_req'] = $this->materialrequest_model->getprMatRequest($rid);
		$data['mat_req_item'] = $this->materialrequest_model->getMatRequestItem($rid);
		$this->load->view('MaterialRequest/prreq_close_view',$data);
	}
	
	public function prdReqClosedView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['mat_rec'] = $this->materialrequest_model->getPrideMatReceipt($rid);
		$this->load->view('MaterialRequest/prd_req_closed_view',$data);
	}
	
	public function prreq_single_recipt(){
		$rc_id = $_POST['rc_id'];
		$data['inward'] = $this->materialrequest_model->getPrideInward($rc_id);
		$data['inward_item'] = $this->materialrequest_model->getPrideInwardItem($rc_id);
		$this->load->view('MaterialRequest/prd_single_view', $data);
	}
	
	public function prdeReceiptList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['rec_list'] = $this->materialrequest_model->getPrdReceiptList($uname);
		$this->load->view('MaterialRequest/prd_receipt_list',$data);
	}
	
	public function prdinView($inid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['inward'] = $this->materialrequest_model->getPrideInward($inid);
		$data['inward_item'] = $this->materialrequest_model->getPrideInwardItem($inid);
		$data['inward_rmk'] = $this->materialrequest_model->getPrideInwardRemark($inid);
		$data['dc_up'] = $this->materialrequest_model->getDcUpload($inid);
		$this->load->view('MaterialRequest/prd_inward_view',$data);
	}
}