<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class ProductRequest extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->model('user_model');
		$this->load->model('master_model');
		$this->load->model('report_model');
		$this->load->model('productrequest_model');
		
		if(!isset($_SESSION['user_logged'])) {
			$this->session->set_flashdata("error", "please login first to view dashboard");
			redirect("Login/login");
		}
	}
	
	public function productRequest()
	{
		$sub_mod_id = $this->uri->segment(3);
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['sub_mod_id'] = $sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['kitchen'] = $this->productrequest_model->getKitchen($sub_mod_id,$branch_id);
		$this->load->view('ProductRequest/product_request',$data);
	}
	
	public function productRequestSanthe()
	{
		$sub_mod_id = $this->uri->segment(3);
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['kitchen'] = $this->productrequest_model->getKitchen($sub_mod_id,$branch_id);
		$this->load->view('ProductRequest/product_request_santhe',$data);
	}
			
	public function fetchCategory()
	{
		$postdata = file_get_contents("php://input");
		$request = json_decode($postdata);
		$dept = $request->dept;
		$sub_mod_id = $this->uri->segment(3);
		$cat_data = $this->productrequest_model->fetchCategory($dept);
		foreach ($cat_data as $cat) 
		{ 
			$data[] = array(
			"cat_name"          => $cat->access_category,
			"pr_cat_id"  			=> $cat->access_cat_id
			);
		} 
		echo json_encode($data);
	}
	
	public function fetchProduct()
	{
		$postdata = file_get_contents("php://input");
		$request = json_decode($postdata);
		$cat = $request->cat;
		$branch_id = $request->branch_id;
		$dept = $request->dept;
		$item_data = $this->productrequest_model->fetchProduct($cat,$branch_id,$dept);
		foreach ($item_data as $item) 
		{ 
			$data[] = array(
			"iname"          => $item->rname,
			"uom"  			=> $item->uom,
			"cat_id"          => $item->pr_cat_id,
			"flavour"  			=> $item->flavour,
			"f_code"          => $item->f_code,
			"id"  			=> $item->recipe_id,
			"qty"          => $item->req_qty,
			"rno"  			=> $item->recipe_no
			);
		} 
		echo json_encode($data);
	}
	
	public function fetchStProduct()
	{
		$postdata = file_get_contents("php://input");
		$request = json_decode($postdata);
		$branch_id = $request->branch_id;
		$dept = $request->dept;
		$item_data = $this->productrequest_model->fetchStProduct($branch_id,$dept);
		foreach ($item_data as $item) 
		{ 
			$data[] = array(
			"iname"          => $item->rname,
			"uom"  			=> $item->uom,
			"cat_id"          => $item->pr_cat_id,
			"flavour"  			=> $item->flavour,
			"f_code"          => $item->f_code,
			"id"  			=> $item->recipe_id,
			"qty"          => $item->req_qty,
			"rno"  			=> $item->recipe_no
			);
		} 
		echo json_encode($data);
	}
	
	public function updateIndentQty()
	{
		$postdata = file_get_contents("php://input");
		$request = json_decode($postdata);
		$value = $request->value;
		$item_id = $request->item_id;
		$query=$this->db->query("UPDATE recipe set req_qty='$value' WHERE recipe_id='$item_id'");
	}
	
	public function addRequest()
	{
		$rid=$this->productrequest_model->addRequest($this->input->post());
		redirect('ProductRequest/requestView/'.$rid);
	}
	
	public function addStRequest()
	{
		$rid=$this->productrequest_model->addStRequest($this->input->post());
		redirect('ProductRequest/requestView/'.$rid);
	}
	
	public function requestView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_req'] = $this->productrequest_model->getPrdRequest($rid);
		$data['prd_req_item'] = $this->productrequest_model->getPrdRequestItem($rid);
		$this->load->view('ProductRequest/request_view',$data);
	}
	
	public function requestList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->productrequest_model->getRequestList($branch_id);
		$this->load->view('ProductRequest/request_list',$data);
	}
	
	public function requestIssueList($req_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->productrequest_model->getPrdRequest($req_id);
		$data['req_iss_list'] = $this->productrequest_model->getRequesIssuetLists($req_id);
		$this->load->view('ProductRequest/request_issue_list',$data);
	}
	
	public function requestReport()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$sub_mod_id = $this->uri->segment(3);
		$data['submod'] = $sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('ProductRequest/request_report',$data);
	}

	public function requestReportbyDate()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];

		$req_date = $this->input->post('req_date');
		$submod = $this->input->post('sub_mod_id');

		$data1 = array(
		'uname' => $uname,
		'req_date' => $req_date
		);
		if($req_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
		} else {
			$result = $this->productrequest_model->getIndentItemsQty($data1);
			if ($result != false) {
				$data['result_display'] = $result;
			} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['submod'] = $submod;
		$data['access_tab'] = $this->productrequest_model->get_accessTab($submod,$branch_id);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['counters'] = $this->productrequest_model->getCounters($data1);
		$data['spl_ord'] = $this->productrequest_model->getSplOrders($data1);
		$data['run_ord'] = $this->productrequest_model->getRunningOrders($data1);
		$data['st_ord'] = $this->productrequest_model->getStIndentItemsQty($data1);
		$data['stspl_ord'] = $this->productrequest_model->getStSplOrders($data1);
		$this->load->view('ProductRequest/request_report',$data);
	}

	public function productIssue()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$sub_mod_id = $this->uri->segment(3);
		$data['submod'] = $sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('ProductRequest/product_issue',$data);
	}
	
	public function productIssueByDate()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		
		$req_date = $this->input->post('req_date');
		$sub_mod_id = $this->input->post('sub_mod_id');

		$data1 = array(
		'uname' => $uname,
		'req_date' => $req_date,
		'branch_id' => $branch_id
		);
		if($req_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
		} else {
			$result = $this->productrequest_model->getIndentItems($data1);
			if ($result != false) {
				$data['result_display'] = $result;
			} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['submod'] = $sub_mod_id;
		$data['access_tab'] = $this->productrequest_model->get_accessTab($sub_mod_id,$branch_id);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['counters'] = $this->productrequest_model->getCounters($data1);
		$data['spl_ord'] = $this->productrequest_model->getSplOrders($data1);
		$data['run_ord'] = $this->productrequest_model->getRunningOrders($data1);
		$data['stspl_ord'] = $this->productrequest_model->getStSplOrders($data1);
		$data['st_ord'] = $this->productrequest_model->getStIndentItems($data1);
		$data['stcounters'] = $this->productrequest_model->getStCounters($data1);
		$this->load->view('ProductRequest/product_issue',$data);
	}
	
	public function addRegularIssue()
	{
		$this->productrequest_model->addRegularIssue($this->input->post());
		redirect('ProductRequest/productIssueList/');
	}
	
	public function addStRegularIssue()
	{
		$this->productrequest_model->addStRegularIssue($this->input->post());
		redirect('ProductRequest/productIssueList/');
	}
	
	public function splOrder(){
		$req_id = $_POST['req_id'];
		$branch_id = $_SESSION['branch_id'];;
		$data['prd_req'] = $this->productrequest_model->getPrdRequest($req_id);
		$data['prd_reqitem'] = $this->productrequest_model->getPrdRequestItm($req_id,$branch_id);
		$this->load->view('ProductRequest/spl_order',$data);
	}
	
	public function addSplOrdIssue()
	{
		$this->productrequest_model->addSplOrdIssue($this->input->post());
		redirect('ProductRequest/productIssueList/');
	}
		
	public function productionIssue()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$sub_mod_id = $this->uri->segment(3);
		$data['sub_mod_id'] = $sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('ProductRequest/production_issue',$data);
	}
	
	public function productionIssueByDate()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];

		$req_date = $this->input->post('req_date');
		$sub_mod_id = $this->input->post('sub_mod_id');

		$data1 = array(
		'uname' => $uname,
		'req_date' => $req_date,
		'branch_id' => $branch_id
		);
		if($req_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
		} else {
			$result = $this->productrequest_model->getIndentItems($data1);
			if ($result != false) {
				$data['result_display'] = $result;
			} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['access_tab'] = $this->productrequest_model->get_accessTab($sub_mod_id,$branch_id);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['counters'] = $this->productrequest_model->getCounters($data1);
		$data['spl_ord'] = $this->productrequest_model->getSplOrders($data1);
		$data['run_ord'] = $this->productrequest_model->getRunningOrders($data1);
		$this->load->view('ProductRequest/production_issue',$data);
	}
	
	public function addProductionIssue()
	{
		$this->productrequest_model->addProductionIssue($this->input->post());
		redirect('ProductRequest/productionIssue/');
	}
	
	public function productionSplOrder(){
		$req_id = $_POST['req_id'];
		$branch_id = $_SESSION['branch_id'];;
		$data['prd_req'] = $this->productrequest_model->getPrdRequest($req_id);
		$data['prd_reqitem'] = $this->productrequest_model->getPrdRequestItm($req_id,$branch_id);
		$this->load->view('ProductRequest/production_spl_order',$data);
	}
	
	public function addProductionSplOrdIssue()
	{
		$this->productrequest_model->addProductionSplOrdIssue($this->input->post());
		redirect('ProductRequest/productIssue/');
	}
	
	public function productIssueList(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issues_list'] = $this->productrequest_model->getIssuetList($branch_id);
		$this->load->view('ProductRequest/issue_list',$data);
	}
	
	public function issueView($isid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->productrequest_model->getIssue($isid);
		$data['issue_item'] = $this->productrequest_model->getIssueItem($isid);
		$this->load->view('ProductRequest/issue_view',$data);
	}
	
	public function issueInward($req_id,$issue_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue'] = $this->productrequest_model->getIssue($issue_id);
		$data['issue_item'] = $this->productrequest_model->getIssuedItemDetail($issue_id);
		$this->load->view('ProductRequest/issue_inward',$data);
	}
	
	public function addInward()
	{
		$inid = $this->productrequest_model->addInward($this->input->post());
		redirect('ProductRequest/inwardView/'.$inid);
	}
	
	public function inwardtList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['inw_list'] = $this->productrequest_model->getInwardtList($branch_id);
		$this->load->view('ProductRequest/inward_list',$data);
	}
	
	public function inwardView($inid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['inward'] = $this->productrequest_model->getInward($inid);
		$data['inward_item'] = $this->productrequest_model->getInwardItem($inid);
		$this->load->view('ProductRequest/inward_view',$data);
	}
	
	public function requestClosedList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->productrequest_model->getRequestClosedList($branch_id);
		$this->load->view('ProductRequest/request_closed_list',$data);
	}
	
	public function reqCloseView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_req'] = $this->productrequest_model->getPrdRequest($rid);
		$data['prd_req_item'] = $this->productrequest_model->getPrdRequestItem($rid);
		$this->load->view('ProductRequest/req_close_view',$data);
	}
	
	public function reqClosedView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_rec'] = $this->productrequest_model->getPrdReceipt($rid);
		$this->load->view('ProductRequest/req_closed_view',$data);
	}
	
	public function req_single_recipt(){
		$inid = $_POST['rc_id'];
		$data['inward'] = $this->productrequest_model->getInward($inid);
		$data['inward_item'] = $this->productrequest_model->getInwardItem($inid);
		$this->load->view('ProductRequest/rc_single_view', $data);
	}
	
	public function issueClosedList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issue_list'] = $this->productrequest_model->getIssueClosedList($uname);
		$this->load->view('ProductRequest/issue_closed_list',$data);
	}
	
	public function prdrequestView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_req'] = $this->productrequest_model->getPrdRequestIss($rid);
		$data['prd_req_item'] = $this->productrequest_model->getPrdRequestItem($rid);
		$this->load->view('ProductRequest/pirequest_view',$data);
	}
	
	public function issueClosedView($rid)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_iss'] = $this->productrequest_model->getPrdIssues($rid);
		$this->load->view('ProductRequest/issue_closed_view',$data);
	}
	
	public function issue_single_recipt(){
		$is_id = $_POST['is_id'];
		$data['issue'] = $this->productrequest_model->getIssue($is_id);
		$data['issue_item'] = $this->productrequest_model->getIssueItem($is_id);
		$this->load->view('ProductRequest/iss_single_view', $data);
	}
	
	public function issuePendingList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['iss_list'] = $this->productrequest_model->getIssuePendingList($uname);
		$this->load->view('ProductRequest/issue_pending_list',$data);
	}
	
	public function requestRmkissUpdate(){
		$req_id = $this->input->post('req_id');
		$req_remark = $this->input->post('req_remark');
		$this->db->query("update product_request set receipt_status='Closed',status='Closed',in_remark='$req_remark' where request_id='$req_id'");
		echo 1;
	}
	
	public function requestCReport()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$sub_mod_id = $this->uri->segment(3);
		$data['sub_mod_id'] = $sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['pr_data'] = $this->productrequest_model->pr_userdata();
		$this->load->view('ProductRequest/requestC_report',$data);
	}

	public function requestCReportbyDate()
	{
		/*$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$uname = $_SESSION['username'];
		$dept=$this->input->post('dept');
		$req_date = $this->input->post('to_date');
		$sub_mod_id = $this->input->post('sub_mod_id');*/
    
        $user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		//$uname = $_SESSION['username'];
        $uname=$this->input->post('dept');
		$req_date = $this->input->post('req_date');
		$submod = $this->input->post('sub_mod_id');

		$data1 = array(
		'uname' => $uname,
		'req_date' => $req_date
		);
		if($req_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
		} else {
			$result = $this->productrequest_model->getIndentItemsQty($data1);
			if ($result != false) {
				$data['result_display'] = $result;
			} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['submod'] = $submod;
		$data['access_tab'] = $this->productrequest_model->get_accessTab($submod,$branch_id);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['counters'] = $this->productrequest_model->getCounters($data1);
		$data['spl_ord'] = $this->productrequest_model->getSplOrders($data1);
		$data['run_ord'] = $this->productrequest_model->getRunningOrders($data1);
		$data['st_ord'] = $this->productrequest_model->getStIndentItemsQty($data1);
		$data['stspl_ord'] = $this->productrequest_model->getStSplOrders($data1);
	//	$this->load->view('ProductRequest/request_report',$data);
	/*	$data1 = array(
		'uname' => $uname,
		'req_date' => $req_date
		);
		$data1 = array(
		'uname' => $dept,
		'req_date' => $req_date
		);
		if($req_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
		} else {
			$result = $this->productrequest_model->getIndentItemsQty($data1);
			if ($result != false) {
				$data['result_display'] = $result;
			} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['santhe_req_item'] = $this->productrequest_model->get_santhe_req_item($req_date,$dept);
		$data['santhe_req_qty'] = $this->productrequest_model->get_santhe_req_qty($req_date,$dept);
		$data['special_req_item'] = $this->productrequest_model->get_req_item_special($req_date,$dept);
		$data['special_req_qty'] = $this->productrequest_model->get_req_qty_special($req_date,$dept);
		$data['regular_req_qty'] = $this->productrequest_model->get_req_qty_regular($req_date,$dept);
		$data['regular_req_item'] = $this->productrequest_model->get_req_item_regular($req_date,$dept);
		$data['access_tab'] = $this->productrequest_model->get_accessTab($sub_mod_id,$branch_id);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['counters'] = $this->productrequest_model->getCounters($data1);
		$data['spl_ord'] = $this->productrequest_model->getSplOrders($data1);
		$data['run_ord'] = $this->productrequest_model->getRunningOrders($data1);*/
		$this->load->view('ProductRequest/requestC_report',$data);
	}
	
	
	 public function productRequestIof()
	{
		$sub_mod_id = $this->uri->segment(3);
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['sub_mod_id'] = $sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['items'] = $this->master_model->get_Products1($branch_id);
		//	$data['items'] = $this->master_model->get_Products1($branch_id);
		//$data['kitchen'] = $this->productrequest_model->getKitchen($sub_mod_id,$branch_id);
		$this->load->view('ProductRequest/prRequestIof',$data);
	}

	public function addPr_RequestIOF(){
		$req_id=$this->productrequest_model->addPr_RequestIOF($this->input->post());
		redirect('ProductRequest/pr_RequestView/'.$req_id);
	}

	public function pr_RequestView($req_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_req'] = $this->productrequest_model->getPrdRequest($req_id);
		$data['prd_req_item'] = $this->productrequest_model->getPrdRequestItem($req_id);
		$this->load->view('ProductRequest/prRequest_view',$data);
	}

	public function request_issuePendingList()
	{
		$user_id = $_SESSION['user_id'];
		$uname = $_SESSION['username'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['req_list'] = $this->productrequest_model->get_pr_request_list_for_issue($uname);
		$this->load->view('ProductRequest/request_issuePending',$data);
	}

	public function addPrIssue($request_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$branch_name = $_SESSION['branch_name'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_req'] = $this->productrequest_model->get_product_request_detail($request_id);
		$data['prd_req_item'] = $this->productrequest_model->get_product_issue_item($request_id,$branch_name);
		//$data['vehicle'] = $this->issue_model->get_vehicle();
		$this->load->view('ProductRequest/addPrIssue',$data);
	}

	public function add_product_Issue(){
	    $outlet_branch=$this->input->post('outlet_branch');
		$is_id=$this->productrequest_model->add_product_Issue($this->input->post());
		    redirect('ProductRequest/pr_taxissue_receipt/'.$is_id);
	}

	public function pr_issue_receipt($is_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_iss'] = $this->productrequest_model->get_pr_issue($is_id);
		$data['prd_iss_item'] = $this->productrequest_model->get_pr_issue_item($is_id);
		$this->load->view('ProductRequest/pr_issue_receipt',$data);
	}
	
	public function addPrOIssue($request_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$branch_name = $_SESSION['branch_name'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_req'] = $this->productrequest_model->get_product_request_detail($request_id);
		$data['prd_req_item'] = $this->productrequest_model->get_product_issue_item($request_id,$branch_name);
		//$data['vehicle'] = $this->issue_model->get_vehicle();
		$this->load->view('ProductRequest/addPrOIssue',$data);
	}

	public function add_product_OutletIssue(){
	    $outlet_branch=$this->input->post('outlet_branch');
		$is_id=$this->productrequest_model->add_product_OutletIssue($this->input->post());
		redirect('ProductRequest/pr_taxissue_receipt/'.$is_id);
	}
	
	public function pr_taxissue_receipt($is_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['prd_iss'] = $this->productrequest_model->get_pr_issue($is_id);
		$data['prd_iss_item'] = $this->productrequest_model->get_pr_issue_item($is_id);
		$this->load->view('ProductRequest/pr_tax_issue_receipt',$data);
	}
	
	public function productIssueCList(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$username = $_SESSION['username'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['issues_list'] = $this->productrequest_model->getIssuetCList($username);
		$this->load->view('ProductRequest/issue_Clist',$data);
	}
}