<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Stock_update extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->model('user_model');
		$this->load->model('master_model');
		$this->load->model('report_model');
		$this->load->model('stockupdate_model');
		
		if(!isset($_SESSION['user_logged'])) {
			$this->session->set_flashdata("error", "please login first to view dashboard");
			redirect("Login/login");
		}
	}
	var $master_url='https://taazamithai.com/inventory';
	public function stock_update(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		
		$this->load->view('Stock_update/stock_update',$data);
	}
	
	public function stockUpdate(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('Stock_update/stockUpdate',$data);
	}

	public function export_Stock(){
		$branchname = $_SESSION['branch_name'];
		$branch_id = $_SESSION['branch_id'];
		
        $this->load->library('Excel');
        $listInfo = $this->stockupdate_model->getcatdata($branch_id);
        $objPHPExcel = new PHPExcel();
        $objPHPExcel->setActiveSheetIndex(0);
        $objPHPExcel->getActiveSheet()->SetCellValue('A1', 'item_id');
        $objPHPExcel->getActiveSheet()->SetCellValue('B1', 'category_id');
        $objPHPExcel->getActiveSheet()->SetCellValue('C1', 'category name');
        $objPHPExcel->getActiveSheet()->SetCellValue('D1', 'item_name');
        $objPHPExcel->getActiveSheet()->SetCellValue('E1', 'uom');
        $objPHPExcel->getActiveSheet()->SetCellValue('F1', 'Closing Stock');
        $objPHPExcel->getActiveSheet()->SetCellValue('G1', 'branch');
       
        // set Row
        $rowCount = 2;
        foreach ($listInfo as $list) {
           //if($list->itm_id != '') {
                $objPHPExcel->getActiveSheet()->SetCellValue('A' . $rowCount, $list->item_id);
                $objPHPExcel->getActiveSheet()->SetCellValue('B' . $rowCount, $list->category_id);
                $objPHPExcel->getActiveSheet()->SetCellValue('C' . $rowCount, $list->category_name);
                $objPHPExcel->getActiveSheet()->SetCellValue('D' . $rowCount, $list->item_name);
                $objPHPExcel->getActiveSheet()->SetCellValue('E' . $rowCount, $list->uom);
                $objPHPExcel->getActiveSheet()->SetCellValue('F' . $rowCount, '0');
                $objPHPExcel->getActiveSheet()->SetCellValue('G' . $rowCount, $branchname);
                $rowCount++;
           //}
        }
        $filename = "Stock_Update(RM)_".$branchname."_". date("d-m-Y").".csv";
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="'.$filename.'"');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'CSV');  
        $objWriter->save('php://output');
		
	}

	public function import_Stock(){
		if(isset($_POST["upload"]))
		{
			$filename=$_FILES["stk_upload"]["tmp_name"];
			if($_FILES["stk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'S%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "STKUP"."/".$branchname."/".$stkno;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from item_creation where item_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$stk[$i] = $res4['stock_item'];
	        			$unitm[$i] = $res4['uom'];
	        			$itm_id[$i] = $res4['itm_id'];
	        			$cat_id[$i] = $res4['category_id'];
					 	
						$pr=$this->db->query("select * from item_creation where itm_id='$itm_id[$i]' and branchname='STR'");
	        			foreach($pr->result_array() as $prs)
	        			$tax = $prs['item_tax'];
	        			$iprice = $prs['item_price'];
	        			$tax_a = ($tax * $iprice)/100;
	        			$rate = $iprice + $tax_a;
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,itm_id,item_price,item_tax,rate)values('Raw Material','$data[3]','$data[4]','$stk[$i]','$data[5]','$stck_id','$data[0]','$cat_id[$i]','$itm_id[$i]','$iprice','$tax','$rate')");
        	
        				$res5 = $this->db->query("update item_creation set stock_item='$data[5]' where item_id='$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,itm_id,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$stk[$i]','$data[5]','$lm','$branchname','$data[0]','$itm_id[$i]','$cat_id[$i]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/stock_receipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/stock_update');
			}
		}
	}
	
	
	public function exportPrStock(){
		$branchname = $_SESSION['branch_name'];
		$branch_id = $_SESSION['branch_id'];
		
        $this->load->library('Excel');
        $listInfo = $this->stockupdate_model->getProductDetail($branch_id);
        $objPHPExcel = new PHPExcel();
        $objPHPExcel->setActiveSheetIndex(0);
        $objPHPExcel->getActiveSheet()->SetCellValue('A1', 'recipe_id');
        $objPHPExcel->getActiveSheet()->SetCellValue('B1', 'pr_cat_id');
        $objPHPExcel->getActiveSheet()->SetCellValue('C1', 'pr_cat_name');
        $objPHPExcel->getActiveSheet()->SetCellValue('D1', 'product_name');
        $objPHPExcel->getActiveSheet()->SetCellValue('E1', 'uom');
        $objPHPExcel->getActiveSheet()->SetCellValue('F1', 'Closing Stock');
        $objPHPExcel->getActiveSheet()->SetCellValue('G1', 'branch');
       
        // set Row
        $rowCount = 2;
        foreach ($listInfo as $list) {
           //if($list->itm_id != '') {
                $objPHPExcel->getActiveSheet()->SetCellValue('A' . $rowCount, $list->recipe_id);
                $objPHPExcel->getActiveSheet()->SetCellValue('B' . $rowCount, $list->pr_cat_id);
                $objPHPExcel->getActiveSheet()->SetCellValue('C' . $rowCount, $list->pr_cat_name);
                $objPHPExcel->getActiveSheet()->SetCellValue('D' . $rowCount, $list->product_name);
                $objPHPExcel->getActiveSheet()->SetCellValue('E' . $rowCount, $list->uom);
                $objPHPExcel->getActiveSheet()->SetCellValue('F' . $rowCount, '0');
                $objPHPExcel->getActiveSheet()->SetCellValue('G' . $rowCount, $branchname);
                $rowCount++;
           //}
        }
        $filename = "Stock_Update(FP)_".$branchname."_". date("d-m-Y").".csv";
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="'.$filename.'"');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'CSV');  
        $objWriter->save('php://output');
	}
	
	public function importPrStock(){
		if(isset($_POST["prupload"]))
		{
			$filename=$_FILES["prstk_upload"]["tmp_name"];
			if($_FILES["prstk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'S%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "STKUP"."/".$branchname."/".$stkno;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from recipe where recipe_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$qty[$i] = $res4['production_stock'];//present stock
						$qty1[$i] = $qty[$i] - $data[5];//consumed stock
						$recipe_no[$i] = $res4['recipe_no'];
					 		        			
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,recipe_no)values('Finished Product','$data[3]','$data[4]','$qty[$i]','$data[5]','$stck_id','$data[0]','$data[1]','$recipe_no[$i]')");
        	
        				$res5=$this->db->query("UPDATE recipe set production_stock='$data[5]' WHERE  recipe_id= '$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,recipe_no,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$qty[$i]','$data[5]','$lm','$branchname','$data[0]','$recipe_no[$i]','$data[1]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/stock_receipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/stock_update');
			}
		}
	}
	
	public function importDailyStock(){
		if(isset($_POST["upload"]))
		{
			$filename=$_FILES["stk_upload"]["tmp_name"];
			if($_FILES["stk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'D%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "DSTKUP"."/".$branchname."/".$stk_no;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from item_creation where item_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$qty[$i] = $res4['stock_item'];//present stock
						$qty1[$i] = $qty[$i] - $data[5];//consumed stock
						$itm_id[$i] = $res4['itm_id'];
					 	$cat_id[$i] = $res4['category_id'];
						$pr=$this->db->query("select * from item_creation where itm_id='$itm_id[$i]' and branchname='STR'");
	        			foreach($pr->result_array() as $prs)
	        			$tax = $prs['item_tax'];
	        			$iprice = $prs['item_price'];
	        			$iprice = $prs['item_price'];
	        			$tax_a = ($tax * $iprice)/100;
	        			$rate = $iprice + $tax_a;
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,itm_id,item_price,item_tax,rate)values('Raw Material','$data[3]','$data[4]','$qty[$i]','$data[5]','$stck_id','$data[0]','$cat_id[$i]','$itm_id[$i]','$iprice','$tax','$rate')");
        	
        				$res5 = $this->db->query("update item_creation set stock_item='$data[5]' where item_id='$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,itm_id,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$qty[$i]','$data[5]','$lm','$branchname','$data[0]','$itm_id[$i]','$cat_id[$i]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/stock_receipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/daily_stock_update');
			}
		}
	}
	
	public function importDailyPrStock(){
		if(isset($_POST["prupload"]))
		{
			$filename=$_FILES["prstk_upload"]["tmp_name"];
			if($_FILES["prstk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'D%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "DSTKUP"."/".$branchname."/".$stk_no;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from recipe where recipe_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$qty[$i] = $res4['production_stock'];//present stock
						$qty1[$i] = (float)$qty[$i] - (float)$data[5];//consumed stock
						$recipe_no[$i] = $res4['recipe_no'];
					 		        			
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,recipe_no)values('Finished Product','$data[3]','$data[4]','$qty[$i]','$data[5]','$stck_id','$data[0]','$data[1]','$recipe_no[$i]')");
        	
        				$res5=$this->db->query("UPDATE recipe set production_stock='$data[5]' WHERE  recipe_id= '$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,recipe_no,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$qty[$i]','$data[5]','$lm','$branchname','$data[0]','$recipe_no[$i]','$data[1]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/dstkstock_receipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/daily_stock_update');
			}
		}
	}
	
	public function DailyStockUpdate(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('Stock_update/daily_stock_update',$data);
	}

		
	public function stock_receipt($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/stock_receipt',$data);
		
	}

	public function dstkstock_receipt($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/dstk_receipt',$data);
		
	}

	public function stock_update_list()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		//$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		//$data['submod_id']=$sub_mod_id;
		$data['stock_update'] = $this->stockupdate_model->stock_update_list($branch_id);
		$this->load->view('Stock_update/stock_update_list',$data);
	}
	
	public function getStockUpdate(){
		
		$branch_id = $_SESSION['branch_id'];
		$data = $this->stockupdate_model->stock_update_list($branch_id);
        $count=1;
        $test = array();
        foreach($data as $row)
    	{
    	    
    	    $view = "<a href='$this->master_url/index.php/Stock_update/viewStockUp/$row->stck_id/' class='btn btn-sm btn-primary'><i class='la la-eye '> </i></a>";
    	    
    	    
    	    $test[] = array(
    	        $count,
    	        $row->stock_no,
    	        $row->stk_date,
                $view
    	   );
    	        
    	        $count++;
    	}
    	$datas = array(
    	    "data" =>$test
    	);
    	
    	echo json_encode($datas);
	}
	
	public function dailyStockUpdateList()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->daily_stock_update_list($branch_id);
		$this->load->view('Stock_update/daily_stock_update_list',$data);
	}
	
	public function getDStockUpdate(){
		
		$branch_id = $_SESSION['branch_id'];
		$data = $this->stockupdate_model->daily_stock_update_list($branch_id);
        $count=1;
        $test = array();
        foreach($data as $row)
    	{
    	    
    	    $view = "<a href='$this->master_url/index.php/Stock_update/viewStockUp/$row->stck_id' class='btn btn-sm btn-primary'><i class='la la-eye '> </i></a>";
    	    
    	    
    	    $test[] = array(
    	        $count,
    	        $row->stock_no,
    	        $row->stk_date,
                $view
    	   );
    	        
    	        $count++;
    	}
    	$datas = array(
    	    "data" =>$test
    	);
    	
    	echo json_encode($datas);
	}
	public function search_Dailystock_update(){
	    $user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$sub_mod_id=$this->input->post('sub_mod_id');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch_id' =>$branch_id
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "Both feilds are required";
			} else {
			$result = $this->stockupdate_model->dailyStock_update_by_branch($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['submod_id']=$sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$this->load->view('Stock_update/daily_stock_update_list',$data);
	}
	
	public function viewStockUp($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		//$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		//$data['submod_id']=$sub_mod_id;
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/viewStockUp',$data);
	}

	public function search_stock_update(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$sub_mod_id=$this->input->post('sub_mod_id');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch_id' =>$branch_id
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "Both feilds are required";
			} else {
			$result = $this->stockupdate_model->stock_update_by_branch($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['submod_id']=$sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$this->load->view('Stock_update/stock_update_list',$data);
	}

	public function import_RawStock(){
		if(isset($_POST["upload"]))
		{
			$filename=$_FILES["stk_upload"]["tmp_name"];
			if($_FILES["stk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'S%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "STKUP"."/".$branchname."/".$stkno;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from item_creation where item_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$stk[$i] = $res4['stock_item'];
	        			$unitm[$i] = $res4['uom'];
	        			$itm_id[$i] = $res4['itm_id'];
	        			$cat_id[$i] = $res4['category_id'];
					 	
						$pr=$this->db->query("select * from item_creation where itm_id='$itm_id[$i]' and branchname='STR'");
	        			foreach($pr->result_array() as $prs)
	        			$tax = $prs['item_tax'];
	        			$iprice = $prs['item_price'];
	        			$tax_a = ($tax * $iprice)/100;
	        			$rate = $iprice + $tax_a;
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,itm_id,item_price,item_tax,rate)values('Raw Material','$data[3]','$data[4]','$stk[$i]','$data[5]','$stck_id','$data[0]','$cat_id[$i]','$itm_id[$i]','$iprice','$tax','$rate')");
        	
        				$res5 = $this->db->query("update item_creation set stock_item='$data[5]' where item_id='$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,itm_id,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$stk[$i]','$data[5]','$lm','$branchname','$data[0]','$itm_id[$i]','$cat_id[$i]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/stock_RawPrReceipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/stock_update');
			}
		}
	}

	public function import_PrStock(){
		if(isset($_POST["prupload"]))
		{
			$filename=$_FILES["prstk_upload"]["tmp_name"];
			if($_FILES["prstk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'S%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "STKUP"."/".$branchname."/".$stkno;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from recipe where recipe_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$qty[$i] = $res4['production_stock'];//present stock
						$qty1[$i] = $qty[$i] - $data[5];//consumed stock
						$recipe_no[$i] = $res4['recipe_no'];
					 		        			
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,recipe_no)values('Finished Product','$data[3]','$data[4]','$qty[$i]','$data[5]','$stck_id','$data[0]','$data[1]','$recipe_no[$i]')");
        	
        				$res5=$this->db->query("UPDATE recipe set production_stock='$data[5]' WHERE  recipe_id= '$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,recipe_no,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$qty[$i]','$data[5]','$lm','$branchname','$data[0]','$recipe_no[$i]','$data[1]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/stock_RawPrReceipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/stock_update');
			}
		}
	}

	public function stock_RawPrReceipt($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/stock_RawReceipt',$data);
	}
	
	public function stSttockUpdate()
	{
		$sub_mod_id = $this->uri->segment(3);
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['cdept'] = $this->stockupdate_model->getCounter($sub_mod_id,$branch_id);
		$this->load->view('Stock_update/st_stock_update',$data);
	}
	
	public function fetchProduct()
	{
		$postdata = file_get_contents("php://input");
		$request = json_decode($postdata);
		$branch_id = $request->branch_id;
		$item_data = $this->stockupdate_model->fetchProduct($branch_id);
		foreach ($item_data as $item) 
		{ 
			$data[] = array(
			"iname"          => $item->rname,
			"uom"  			=> $item->uom,
			"cat_id"          => $item->pr_cat_id,
			"flavour"  			=> $item->flavour,
			"f_code"          => $item->f_code,
			"id"  			=> $item->recipe_id,
			"qty"          => 0,
			"rno"  			=> $item->recipe_no,
			"pr_stk"    => $item->production_stock
			);
		} 
		echo json_encode($data);
	}
	
	public function addStStock()
	{
		$stck_id=$this->stockupdate_model->addStStock($this->input->post());
		//redirect('Stock_update/stk_transfer_inv/'.$sid);
		redirect('Stock_update/stock_RawPrReceipt/'.$stck_id);
	}
	
	public function allStock_update_list($sub_mod_id)
	{
		$user_id = $_SESSION['user_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$data['submod_id']=$sub_mod_id;
		$data['branch'] = $this->user_model->get_branch();
		$data['stock_update'] = $this->stockupdate_model->allstock_update_list();
		$this->load->view('Stock_update/Allstock_up_list',$data);
		
	}

    public function getAllStockUpdate(){
		
		$branch_id = $_SESSION['branch_id'];
		$data = $this->stockupdate_model->allstock_update_list();
        $count=1;
        $test = array();
        foreach($data as $row)
    	{
    	    
    	    $view = "<a href='$this->master_url/index.php/Stock_update/viewStockUp/$row->stck_id' class='btn btn-sm btn-primary'><i class='la la-eye '> </i></a>";
    	    
    	    
    	    $test[] = array(
    	        $count,
    	        $row->stock_no,
    	        $row->stk_date,
                $view
    	   );
    	        
    	        $count++;
    	}
    	$datas = array(
    	    "data" =>$test
    	);
    	
    	echo json_encode($datas);
	}
	
	public function searchCStockUpdate()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$branch = $this->input->post('branch');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch' =>$branch
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
			} else {
			$result = $this->stockupdate_model->getCStockUpdate($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['branch'] = $this->user_model->get_branch();
		$data['items'] = $this->master_model->get_Items($branch_id);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('Stock_update/Allstock_up_list',$data);
	}

	public function export_stkUpdate(){
	
		$from_date = date('Y-m-d',strtotime($this->input->post('from_date1')));;
		$to_date = date('Y-m-d',strtotime($this->input->post('to_date1')));
		$branchn = $this->input->post('branchn');
		$this->load->dbutil();
		$this->load->helper('file');
		$this->load->helper('download');
		$delimiter = ",";
		$newline = "\r\n";
		
		$filename = "Stock_Update_Report.csv";
		$query = "SELECT stock_no,DATE_FORMAT(stk_date, '%d-%m-%Y') as stk_date,branchname FROM stock_update where stk_date between '$from_date' and '$to_date' and branchname='$branchn' and stock_no LIKE 'S%'";
		$result = $this->db->query($query);
		$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
		force_download($filename, $data);
		
	}

	public function allDailyStock_update_list($sub_mod_id)
	{
		$user_id = $_SESSION['user_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$data['submod_id']=$sub_mod_id;
		$data['branch'] = $this->user_model->get_branch();
		$data['stock_update'] = $this->stockupdate_model->alldailystock_update_list();
		$this->load->view('Stock_update/AllDailystock_up_list',$data);
		
	}

	public function searchCDailyStockUpdate()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$branch = $this->input->post('branch');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch' =>$branch
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "All feilds are required";
			} else {
			$result = $this->stockupdate_model->getCDailyStockUpdate($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['branch'] = $this->user_model->get_branch();
		$data['items'] = $this->master_model->get_Items($branch_id);
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('Stock_update/AllDailystock_up_list',$data);
	}
	
	public function export_dstkUpdate(){
	
		$from_date = date('Y-m-d',strtotime($this->input->post('from_date')));;
		$to_date = date('Y-m-d',strtotime($this->input->post('to_date')));
		$branchn = $this->input->post('branchn');
		$this->load->dbutil();
		$this->load->helper('file');
		$this->load->helper('download');
		$delimiter = ",";
		$newline = "\r\n";
		
		$filename = "DailyStock_Update_Report.csv";
		$query = "SELECT stock_no,DATE_FORMAT(stk_date, '%d-%m-%Y') as stk_date,branchname FROM stock_update where stk_date between '$from_date' and '$to_date' and branchname='$branchn' and stock_no LIKE 'D%'";
		$result = $this->db->query($query);
		$data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
		force_download($filename, $data);
		
	}
	
	public function actStkUpdate()
	{
		$sub_mod_id = $this->uri->segment(3);
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['sub_mod_id'] = $sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['items'] = $this->master_model->get_Products($branch_id);
		$this->load->view('Stock_update/actStkUpdate',$data);
	}
	
	

	public function addActStock(){
		$stck_id=$this->stockupdate_model->addActStock($this->input->post());
		redirect('Stock_update/stock_PrReceipt/'.$stck_id);
	}

	public function stock_PrReceipt($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/stock_APrReceipt',$data);
	}
	
	public function actStock_update_list($sub_mod_id)
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$data['submod_id']=$sub_mod_id;
		$data['stock_update'] = $this->stockupdate_model->astock_update_list($branch_id);
		$this->load->view('Stock_update/actual_update_list',$data);
	}
	
	public function getact_StockUpdate(){
		
		$branch_id = $_SESSION['branch_id'];
		$data = $this->stockupdate_model->astock_update_list($branch_id);
        $count=1;
        $test = array();
        foreach($data as $row)
    	{
    	    
    	    $view = "<a href='$this->master_url/index.php/Stock_update/stock_PrReceipt/$row->stck_id' class='btn btn-sm btn-primary'><i class='la la-eye '> </i></a>";
    	    
    	    
    	    $test[] = array(
    	        $count,
    	        $row->stock_no,
    	        $row->stk_date,
                $view
    	   );
    	        
    	        $count++;
    	}
    	$datas = array(
    	    "data" =>$test
    	);
    	
    	echo json_encode($datas);
	}
	
	
	public function stock_updateMStore(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		
		$this->load->view('Stock_update/stock_updateMby',$data);
	}
	
	public function import_MBYStock(){
		if(isset($_POST["upload"]))
		{
			$filename=$_FILES["stk_upload"]["tmp_name"];
			if($_FILES["stk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'S%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "STKUP"."/".$branchname."/".$stkno;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from item_creation where item_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$stk[$i] = $res4['stock_item'];
	        			$unitm[$i] = $res4['uom'];
	        			$itm_id[$i] = $res4['itm_id'];
	        			$cat_id[$i] = $res4['category_id'];
					 	
						$pr=$this->db->query("select * from item_creation where itm_id='$itm_id[$i]' and branchname='MBY'");
	        			foreach($pr->result_array() as $prs)
	        			$tax = $prs['item_tax'];
	        			$iprice = $prs['item_price'];
	        			$tax_a = ($tax * $iprice)/100;
	        			$rate = $iprice + $tax_a;
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,itm_id,item_price,item_tax,rate)values('Raw Material','$data[3]','$data[4]','$stk[$i]','$data[5]','$stck_id','$data[0]','$cat_id[$i]','$itm_id[$i]','$iprice','$tax','$rate')");
        	
        				$res5 = $this->db->query("update item_creation set stock_item='$data[5]' where item_id='$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,itm_id,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$stk[$i]','$data[5]','$lm','$branchname','$data[0]','$itm_id[$i]','$cat_id[$i]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/stock_Mreceipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/stock_updateMby');
			}
		}
	}
	
	public function stock_Mreceipt($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/stock_Mreceipt',$data);
		
	}
	
	
	public function stock_updateMBY_list()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		//$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		//$data['submod_id']=$sub_mod_id;
		$data['stock_update'] = $this->stockupdate_model->stock_update_list($branch_id);
		$this->load->view('Stock_update/stock_updateMBY_list',$data);
	}
	
	public function getStockUpdateMBy(){
		
		$branch_id = $_SESSION['branch_id'];
		$data = $this->stockupdate_model->stock_update_list($branch_id);
        $count=1;
        $test = array();
        foreach($data as $row)
    	{
    	    
    	    $view = "<a href='$this->master_url/index.php/Stock_update/viewMBYStockUp/$row->stck_id/' class='btn btn-sm btn-primary'><i class='la la-eye '> </i></a>";
    	    
    	    
    	    $test[] = array(
    	        $count,
    	        $row->stock_no,
    	        $row->stk_date,
                $view
    	   );
    	        
    	        $count++;
    	}
    	$datas = array(
    	    "data" =>$test
    	);
    	
    	echo json_encode($datas);
	}
	
	public function viewMBYStockUp($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		//$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		//$data['submod_id']=$sub_mod_id;
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/viewMBYStockUp',$data);
	}

	public function search_Mstock_update(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$sub_mod_id=$this->input->post('sub_mod_id');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch_id' =>$branch_id
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "Both feilds are required";
			} else {
			$result = $this->stockupdate_model->stock_update_by_branch($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['submod_id']=$sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$this->load->view('Stock_update/stock_updateMBY_list',$data);
	}
	
	public function DailyStockUpdateMBY(){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$this->load->view('Stock_update/daily_stock_updateMBY',$data);
	}
	
	public function importDailyStockMBY(){
		if(isset($_POST["upload"]))
		{
			$filename=$_FILES["stk_upload"]["tmp_name"];
			if($_FILES["stk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'D%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "DSTKUP"."/".$branchname."/".$stk_no;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from item_creation where item_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$qty[$i] = $res4['stock_item'];//present stock
						$qty1[$i] = $qty[$i] - $data[5];//consumed stock
						$itm_id[$i] = $res4['itm_id'];
					 	$cat_id[$i] = $res4['category_id'];
						$pr=$this->db->query("select * from item_creation where itm_id='$itm_id[$i]' and branchname='MBY'");
	        			foreach($pr->result_array() as $prs)
	        			$tax = $prs['item_tax'];
	        			$iprice = $prs['item_price'];
	        			$iprice = $prs['item_price'];
	        			$tax_a = ($tax * $iprice)/100;
	        			$rate = $iprice + $tax_a;
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,itm_id,item_price,item_tax,rate)values('Raw Material','$data[3]','$data[4]','$qty[$i]','$data[5]','$stck_id','$data[0]','$cat_id[$i]','$itm_id[$i]','$iprice','$tax','$rate')");
        	
        				$res5 = $this->db->query("update item_creation set stock_item='$data[5]' where item_id='$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,itm_id,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$qty[$i]','$data[5]','$lm','$branchname','$data[0]','$itm_id[$i]','$cat_id[$i]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/stock_Mreceipt/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/DailyStockUpdateMBY');
			}
		}
	}
	
	public function importDailyPrStockMBY(){
		if(isset($_POST["prupload"]))
		{
			$filename=$_FILES["prstk_upload"]["tmp_name"];
			if($_FILES["prstk_upload"]["size"] > 0)
			{
				$file = fopen($filename, "r");

				$branchname = $_SESSION['branch_name'];
				$branch_id = $_SESSION['branch_id'];
				$user = $_SESSION['full_name'];
				$stk_date = date("Y-m-d");
				$order_time = date("h:i A");
				$lm=date("Y-m-dH:i:s",time());
				
				$result = $this->db->query("SELECT MAX(stk_no) as stk_no FROM stock_update where branch_id='$branch_id' and `stock_no` like 'D%'");
				foreach($result->result_array() as $res)
				$stk_no = $res['stk_no'];
				if($stk_no == 0){
					$stkno = 1;
				}
				else{
					$stkno = $stk_no+1;
				}
				
		    	$stock_no = "DSTKUP"."/".$branchname."/".$stk_no;
		    	$res2 = $this->db->query("insert into stock_update(stk_no,stock_no,stk_date,branchname,user_name,stk_time,branch_id)values('$stkno','$stock_no','$stk_date','$branchname','$user','$order_time','$branch_id')");
		    	$stck_id = $this->db->insert_id();
		    	$i=0;
				while (($data = fgetcsv($file, 10000, ",")) !== FALSE)
				{
					$res3=$this->db->query("select * from recipe where recipe_id='$data[0]'");
	        		if($res3->num_rows() > 0)
	        		{
	        			foreach($res3->result_array() as $res4)
	        			$qty[$i] = $res4['production_stock'];//present stock
						$qty1[$i] = $qty[$i] - $data[5];//consumed stock
						$recipe_no[$i] = $res4['recipe_no'];
					 		        			
        				$this->db->query("insert into stock_update_item(item_type,item_name,uom,present_stk,closing_stk,stck_id,item_id,cat_id,recipe_no)values('Finished Product','$data[3]','$data[4]','$qty[$i]','$data[5]','$stck_id','$data[0]','$data[1]','$recipe_no[$i]')");
        	
        				$res5=$this->db->query("UPDATE recipe set production_stock='$data[5]' WHERE  recipe_id= '$data[0]'");
        				$this->db->query("insert into stock_detail(item_name,trans_ref_no,transaction_date,opening_stock,closing_stock,last_modified,branchname,item_id,recipe_no,category_id,branch_id)values('$data[3]','$stock_no','$stk_date','$qty[$i]','$data[5]','$lm','$branchname','$data[0]','$recipe_no[$i]','$data[1]','$branch_id')");				
					
					}
				}                   
				fclose($file);
				$this->session->set_flashdata('message', 'Data are imported successfully..');
				redirect('Stock_update/dstkstock_receiptMBY/'.$stck_id);
			}else{
				$this->session->set_flashdata('message', 'Something went wrong..');
				redirect('Stock_update/DailyStockUpdateMBY');
			}
		}
	}
	
	public function dstkstock_receiptMBY($stck_id){
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->stock_update($stck_id);
		$data['stk_update_items'] = $this->stockupdate_model->stk_update_items($stck_id);
		$this->load->view('Stock_update/dstk_receiptMBY',$data);
		
	}
	
	public function dailyStockUpdateListMBY()
	{
		$user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['stock_update'] = $this->stockupdate_model->daily_stock_update_list($branch_id);
		$this->load->view('Stock_update/daily_stock_update_listMBY',$data);
	}
	
	public function getDStockUpdateMBY(){
		
		$branch_id = $_SESSION['branch_id'];
		$data = $this->stockupdate_model->daily_stock_update_list($branch_id);
        $count=1;
        $test = array();
        foreach($data as $row)
    	{
    	    
    	    $view = "<a href='$this->master_url/index.php/Stock_update/viewMBYStockUp/$row->stck_id' class='btn btn-sm btn-primary'><i class='la la-eye '> </i></a>";
    	    
    	    
    	    $test[] = array(
    	        $count,
    	        $row->stock_no,
    	        $row->stk_date,
                $view
    	   );
    	        
    	        $count++;
    	}
    	$datas = array(
    	    "data" =>$test
    	);
    	
    	echo json_encode($datas);
	}
	public function search_Dailystock_updateMBY(){
	    $user_id = $_SESSION['user_id'];
		$branch_id = $_SESSION['branch_id'];
		$data['branch_name'] = $_SESSION['branch_name'];
		
		
		$from_date = $this->input->post('from_date');
		$to_date = $this->input->post('to_date');
		$sub_mod_id=$this->input->post('sub_mod_id');
		
		$data1 = array(
		'from_date' => $from_date,
		'to_date' => $to_date,
		'branch_id' =>$branch_id
		);
		if ($from_date == "" && $to_date == "") {
			$data['date_range_error_message'] = "Both feilds are required";
			} else {
			$result = $this->stockupdate_model->dailyStock_update_by_branch($data1);
			if ($result != false) {
				$data['result_display'] = $result;
				} else {
				$data['result_display'] = "No record found !";
			}
		}
		$data['submod_id']=$sub_mod_id;
		$data['side_bar_data'] = $this->user_model->get_SideBarData($user_id);
		$data['thead_permission'] = $this->user_model->get_thead_permission($user_id,$sub_mod_id);
		$this->load->view('Stock_update/daily_stock_update_listMBY',$data);
	}
}
?>